C ----------------------------------------------------------
      SUBROUTINE IRKGAUSS(N,FCN,FCNSAVE,
     &                    NSTEP,tau,W,tauEND,METH,IOUT)
C ----------------------------------------------------------
      PARAMETER (NDGL=50,NSD=15,NMD=3)
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(N),F(NDGL*NSD),WH(NDGL)
      REAL*8 Z(NDGL,NSD),ZN(NDGL,NSD),ZNN(NDGL,NSD)
      REAL*8 C(NSD),A(NSD,NSD),E(NSD,NSD),B(NSD),FS(NDGL)
      REAL*8 SM(NMD),AM(NSD)
      common /count/nfcn
      EXTERNAL FCN,FCNSAVE
      DATA UROUND/5.0D-16/     
      NS=METH
      NSS=NS*N
      H=(tauEND-tau)/NSTEP
      CALL COEFG(NS,C,B,NSD,A,E,NM,SM,NMD,AM,H)
      IF (IOUT.NE.0) CALL WRITESOL (0,tau,tau,W,N,IRTRN)
      CALL FCNSAVE(N,0,tau,tau,W)
      CALL FCN(N,tau,W,FS)
      DO IS=1,NS
        DO I=1,N
          ZN(I,IS)=C(IS)*FS(I)
          Z(I,IS)=0.0D0
        END DO
      END DO
      DO ISTEP=1,NSTEP
C --- STARTING APPROXIMATIONS
        if (ISTEP.GT.1) CALL STARTB (FCN,N,tau,W,NS,NDGL,FS,
     &                   Z,ZN,NSD,E,NM,SM,NMD,AM)
C --- LOOP FOR THE ITERATIONS
        NITER=0
  40    CONTINUE
C ---     COMPUTE THE RIGHT-HAND SIDE
        CALL RKITER(FCN,N,NS,NSS,tau,W,WH,NSD,A,C,NDGL,ZN,ZNN,F,DYNO)
        NITER=NITER+1
C ---     BAD CONVERGENCE OR NUMBER OF ITERATIONS TO LARGE
        IF (NITER.GE.50) THEN
          WRITE (6,*) 'NO CONVERGENCE OF ITERATION',DYNO
          RETURN
        END IF
        DO I=1,N
          DO IS=1,NS
            ZN(I,IS)=ZNN(I,IS)
          END DO
        END DO
        IF (DYNO.GT.UROUND) GOTO 40
        tau=tau+H
        DO I=1,N
          SUM=0.D0
          DO IS=1,NS/2
            SUM=SUM+(F(I+(IS-1)*N)+F(I+(NS-IS)*N))*B(IS)
          END DO
          IF (2*(NS/2).NE.NS) THEN
            IS=1+NS/2
            SUM=SUM+F(I+(IS-1)*N)*B(IS)
          END IF
          W(I)=W(I)+H*SUM
        END DO
        IF (IOUT.NE.0) CALL WRITESOL (ISTEP,tau-H,tau,W,N,IRTRN)
        CALL FCNSAVE(N,ISTEP,tau-H,tau,W)
      END DO
      RETURN
      END
C ------------------------------------------------------------


C ----------------------------------------------------------
      SUBROUTINE STARTB (FCN,N,tau,W,NS,NDGL,FS,Z,ZN,NSD,E,
     &                   NM,SM,NMD,AM)
C ----------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Z(NDGL,NS),ZN(NDGL,NS+NM),E(NSD,NS+NM),F(100)
      REAL*8 AM(NS),SM(NM),W(N),WH(100),FS(N)
        DO I=1,N
          DO IS=1,NS
            SAV=0.0D0
            DO JS=1,NS
              SAV=SAV+E(IS,JS)*ZN(I,JS)
            END DO
            Z(I,IS)=SAV+E(IS,NS+1)*FS(I)
          END DO
          SAV=0.0D0
          DO JS=1,NS
            SAV=SAV+AM(JS)*ZN(I,JS)
          END DO
          WH(I)=SAV+AM(NS+1)*FS(I)
        END DO
        CALL FCN(N,tau+H,W,FS)
        DO I=1,N
          WH(I)=WH(I)+AM(NS+2)*FS(I)+W(I)
        END DO
        CALL FCN(N,tau+H*SM(NM),WH,F)
        DO I=1,N
          DO IS=1,NS
            Z(I,IS)=Z(I,IS)+E(IS,NS+2)*FS(I)+E(IS,NS+NM)*F(I)
            ZN(I,IS)=Z(I,IS)
          END DO
        END DO
        RETURN
      END
C -------------------------------------------------------------------


C -------------------------------------------------------------------
      SUBROUTINE RKITER(FCN,N,NS,NSS,tau,W,WH,NSD,A,C,NDGL,Z,ZN,F,DYNO)
C -------------------------------------------------------------------
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 Z(NDGL,NS),ZN(NDGL,NS),W(N),C(NS)
      REAL*8 A(NSD,NS),F(NDGL*NS),WH(NDGL)
      EXTERNAL FCN
      DO JS=1,NS
        DO J=1,N
          WH(J)=W(J)+Z(J,JS)
        END DO
        CALL FCN(N,tau+C(JS),WH,F(1+(JS-1)*N))
      END DO
C ---
      DO IS=1,NS
        DO I=1,N
          SUM=0.0D0
          DO JS=1,NS
            SUM=SUM+A(IS,JS)*F(I+(JS-1)*N)
          END DO
          ZN(I,IS)=SUM
        END DO
      END DO
C ---   
      DYNO=0.D0
      DO I=1,N
        DO IS=1,NS
          DYNO=DYNO+(ZN(I,IS)-Z(I,IS))**2
        END DO
      END DO
      DYNO=DSQRT(DYNO/NS)
      RETURN
      END
C --------------------------------------------------------------


C ----------------------------------------------------------
      SUBROUTINE COEFG(NS,C,B,NSD,A,E,NM,SM,NMD,AM,HSTEP)
C ----------------------------------------------------------     
      IMPLICIT REAL*8 (A-H,O-Z)
      REAL*8 C(NS),A(NSD,NS),B(NS),E(NSD,NS+NMD)
      REAL*8 AM(NS+NMD),SM(NMD)
      NM=3
      IF (NS.EQ.2) THEN
         C(1)= 0.21132486540518711775D+00
         C(2)= 0.78867513459481288225D+00
         B(1) = 0.5D+00
         A(1,1)= 0.25000000000000000000D+00
         A(1,2)=-0.38675134594812882255D-01
         A(2,1)= 0.53867513459481288225D+00
         A(2,2)= 0.25000000000000000000D+00
         E(1,1)= 0.18294868775438310050D+01
         E(1,2)=-0.82948687754383100497D+00
         E(1,3)= 0.61528623219020494496D-02
         E(1,4)= 0.50937579020480312297D+00
         E(1,5)=-0.36624180487512199105D-01
         E(2,1)= 0.13749414229983764595D+01
         E(2,2)=-0.37494142299837645952D+00
         E(2,3)=-0.85698316867356594904D-01
         E(2,4)= 0.36941208858307566491D+00
         E(2,5)= 0.51010902897236068395D+00
         SM(1)= 0.00000000000000000000D+00
         SM(2)= 0.10000000000000000000D+01
         SM(3)= 0.16000000000000000000D+01
         AM(1)= 0.25279583039343438291D+02
         AM(2)=-0.86907830393434382912D+01
         AM(3)=-0.80640000000000000000D+00
         AM(4)= 0.29184000000000000000D+01
         AM(5)= 0.00000000000000000000D+00
      END IF
      IF (NS.EQ.3) THEN
         C(1)=  .112701665379258311482073460022D+00
         C(2)=  .500000000000000000000000000000D+00
         C(3)=  .887298334620741688517926539978D+00
         B(1)=  .277777777777777777777777777778D+00
         B(2)=  .444444444444444444444444444444D+00
         B(3)=  .277777777777777777777777777778D+00
         A(1,1)=  .138888888888888888888888888889D+00
         A(1,2)= -.359766675249389034563954710966D-01
         A(1,3)=  .978944401530832604958004222948D-02
         A(2,1)=  .300263194980864592438024947213D+00
         A(2,2)=  .222222222222222222222222222222D+00
         A(2,3)= -.224854172030868146602471694354D-01
         A(3,1)=  .267988333762469451728197735548D+00
         A(3,2)=  .480421111969383347900839915541D+00
         A(3,3)=  .138888888888888888888888888889D+00
         E(1,1)= -.203559639244158311680180131854D-01
         E(1,2)=  .394171918129825289790090969853D-02
         E(1,3)=  .502831129010386472903941503087D-01
         E(1,4)=  .133500705476872079274554971872D-01
         E(1,5)= -.461425909380202451558229919235D-01
         E(1,6)=  .527448492204112394912717792537D-02
         E(2,1)=  .104287348715829707852459381890D+00
         E(2,2)= -.641762452107279693486590038315D-01
         E(2,3)= -.122007655229239669538283136679D+00
         E(2,4)= -.630387931034482758620689655173D-01
         E(2,5)=  .262452107279693486590038314176D+00
         E(2,6)=  .748323754789272030651340996169D-02
         E(3,1)=  .125962097826930701368609681110D+00
         E(3,2)= -.874666233958576398710809863286D-01
         E(3,3)= -.210295377071752751207460914015D+00
         E(3,4)= -.741259326166527251688348075327D-01
         E(3,5)=  .495184736531889976956589275446D+00
         E(3,6)=  .144390266035813282181141021308D+00
         SM(1)=  .000000000000000000000000000000D+00
         SM(2)=  .100000000000000000000000000000D+01
         SM(3)=  .160000000000000000000000000000D+01
         AM(1)= -.151331141294016412553591094556D+03
         AM(2)=  .976166400000000000000000000000D+02
         AM(3)= -.466304587059835874464089054442D+02
         AM(4)=  .232704000000000000000000000000D+01
         AM(5)=  .789504000000000000000000000000D+01
         AM(6)=  .000000000000000000000000000000D+00
      END IF
      IF (NS.EQ.4) THEN
         C(1)= 0.69431844202973712388D-01
         C(2)= 0.33000947820757186760D+00
         C(3)= 0.66999052179242813240D+00
         C(4)= 0.93056815579702628761D+00
         B(1) = 0.173927422568726928686D+00
         B(2) = 0.326072577431273071313D+00
         A(1,1)= 0.86963711284363464343D-01
         A(1,2)=-0.26604180084998793313D-01
         A(1,3)= 0.12627462689404724515D-01
         A(1,4)=-0.35551496857956831569D-02
         A(2,1)= 0.18811811749986807165D+00
         A(2,2)= 0.16303628871563653566D+00
         A(2,3)=-0.27880428602470895224D-01
         A(2,4)= 0.67355005945381555154D-02
         A(3,1)= 0.16719192197418877317D+00
         A(3,2)= 0.35395300603374396654D+00
         A(3,3)= 0.16303628871563653566D+00
         A(3,4)=-0.14190694931141142964D-01
         A(4,1)= 0.17748257225452261184D+00
         A(4,2)= 0.31344511474186834680D+00
         A(4,3)= 0.35267675751627186463D+00
         A(4,4)= 0.86963711284363464343D-01
         E(1,1)= 0.23567552853399403185D+01
         E(1,2)=-0.22096763719934129798D+01
         E(1,3)= 0.23656662336793468127D+01
         E(1,4)=-0.12735501449272813794D+01
         E(1,5)= 0.27342844286196362782D-01
         E(1,6)= 0.20916528193619448084D+00
         E(1,7)=-0.13447458960660425884D-02
         E(2,1)= 0.72653040359425296393D+01
         E(2,2)=-0.89953622075319265573D+01
         E(2,3)= 0.11264543832055893666D+02
         E(2,4)=-0.65883213517069309422D+01
         E(2,5)= 0.20713650009267251765D+00
         E(2,6)= 0.11547384390390298170D+01
         E(2,7)= 0.15990319824078581266D-01
         E(3,1)= 0.26566233313263726905D+02
         E(3,2)=-0.34538720486166966593D+02
         E(3,3)= 0.41349477705185567796D+02
         E(3,4)=-0.23466769892456604953D+02
         E(3,5)= 0.88546969216384698242D+00
         E(3,6)= 0.32881128755551462317D+01
         E(3,7)= 0.18364114499906269913D+00
         E(4,1)=-0.33175637495893227802D+02
         E(4,2)= 0.49482926732025634383D+02
         E(4,3)=-0.56201979549432262082D+02
         E(4,4)= 0.30591688340030859793D+02
         E(4,5)=-0.15563947592959166725D+01
         E(4,6)=-0.30752514468308534559D+01
         E(4,7)= 0.72296782764528553942D+00
         SM(1)= 0.00000000000000000000D+00
         SM(2)= 0.10000000000000000000D+01
         SM(3)= 0.16500000000000000000D+01
         AM(1)= 0.10806374869244001787D+04
         AM(2)=-0.66008818661284690206D+03
         AM(3)= 0.61810154357557529566D+03
         AM(4)=-0.31341427826212857229D+03
         AM(5)=-0.10187174765625000000D+02
         AM(6)= 0.31173050390625000000D+02
         AM(7)= 0.00000000000000000000D+00
      END IF
      IF (NS.EQ.6) THEN
         C(1)= 0.33765242898423986094D-01
         C(2)= 0.16939530676686774317D+00
         C(3)= 0.38069040695840154568D+00
         C(4)= 0.61930959304159845432D+00
         C(5)= 0.83060469323313225683D+00
         C(6)= 0.96623475710157601391D+00
         B(1) = 0.856622461895851725201D-01
         B(2) = 0.180380786524069303785D+00
         B(3) = 0.233956967286345523695D+00
         A(1,1)= 0.42831123094792586260D-01
         A(1,2)=-0.14763725997197412475D-01
         A(1,3)= 0.93250507064777511914D-02
         A(1,4)=-0.56688580494835119009D-02
         A(1,5)= 0.28544333150993351309D-02
         A(1,6)=-0.81278017126476211230D-03
         A(2,1)= 0.92673491430378863187D-01
         A(2,2)= 0.90190393262034651892D-01
         A(2,3)=-0.20300102293239585952D-01
         A(2,4)= 0.10363156240246423731D-01
         A(2,5)=-0.48871929280376714634D-02
         A(2,6)= 0.13555610554850617755D-02
         A(3,1)= 0.82247922612843873808D-01
         A(3,2)= 0.19603216233324500606D+00
         A(3,3)= 0.11697848364317276185D+00
         A(3,4)=-0.20482527745656097630D-01
         A(3,5)= 0.79899918996623357972D-02
         A(3,6)=-0.20756257848663341936D-02
         A(4,1)= 0.87737871974451506714D-01
         A(4,2)= 0.17239079462440696799D+00
         A(4,3)= 0.25443949503200162132D+00
         A(4,4)= 0.11697848364317276185D+00
         A(4,5)=-0.15651375809175702271D-01
         A(4,6)= 0.34143235767412987124D-02
         A(5,1)= 0.84306685134100110745D-01
         A(5,2)= 0.18526797945210697525D+00
         A(5,3)= 0.22359381104609909996D+00
         A(5,4)= 0.25425706957958510965D+00
         A(5,5)= 0.90190393262034651892D-01
         A(5,6)=-0.70112452407936906664D-02
         A(6,1)= 0.86475026360849934632D-01
         A(6,2)= 0.17752635320896996865D+00
         A(6,3)= 0.23962582533582903560D+00
         A(6,4)= 0.22463191657986777250D+00
         A(6,5)= 0.19514451252126671626D+00
         A(6,6)= 0.42831123094792586260D-01
         E(1,1)= 0.28772405097504007704D+01
         E(1,2)=-0.26271602588068367102D+01
         E(1,3)= 0.24376955698111635350D+01
         E(1,4)=-0.25313809486926997469D+01
         E(1,5)= 0.28917871367864531513D+01
         E(1,6)=-0.15697030266358168128D+01
         E(1,7)= 0.21678944391047551078D-01
         E(1,8)= 0.11446620454622407816D+00
         E(1,9)=-0.31171088383134637746D-04
         E(2,1)= 0.21307600739521819689D+02
         E(2,2)=-0.19602802912822044491D+02
         E(2,3)= 0.18492376216274770998D+02
         E(2,4)=-0.20220376462465496339D+02
         E(2,5)= 0.26020029912028819954D+02
         E(2,6)=-0.15090969286510127716D+02
         E(2,7)= 0.16319241245420083106D+00
         E(2,8)= 0.10589833026668685717D+01
         E(2,9)= 0.24906069789255294060D-03
         E(3,1)= 0.25383653129409402908D+03
         E(3,2)=-0.25433028385983373551D+03
         E(3,3)= 0.24217944655067644918D+03
         E(3,4)=-0.26242770647893538885D+03
         E(3,5)= 0.31946984937501993263D+03
         E(3,6)=-0.17888891748636540531D+03
         E(3,7)= 0.26808109366918867964D+01
         E(3,8)= 0.10030575458203760588D+02
         E(3,9)= 0.49458671661595522859D-02
         E(4,1)= 0.96261400627686268188D+03
         E(4,2)=-0.10113420404920805597D+04
         E(4,3)= 0.96773275354477500560D+03
         E(4,4)=-0.10451434188835233116D+04
         E(4,5)= 0.12478458739257319887D+04
         E(4,6)=-0.68997366671077982616D+03
         E(4,7)= 0.11828657562134222476D+02
         E(4,8)= 0.36623755098358237827D+02
         E(4,9)= 0.51264979958249029295D-01
         E(5,1)= 0.10299941416386208363D+04
         E(5,2)=-0.10822697903287655658D+04
         E(5,3)= 0.10357256045043082723D+04
         E(5,4)=-0.11188364380831279235D+04
         E(5,5)= 0.13361084480802025272D+04
         E(5,6)=-0.73882093325859357950D+03
         E(5,7)= 0.12660074093407077847D+02
         E(5,8)= 0.39192513781665410512D+02
         E(5,9)= 0.24329219724955682895D+00
         E(6,1)=-0.11906246516823371473D+04
         E(6,2)= 0.14595511076323507663D+04
         E(6,3)=-0.14097579058632554414D+04
         E(6,4)= 0.14986075298030440673D+04
         E(6,5)=-0.17000270182081822318D+04
         E(6,6)= 0.91060820893755726671D+03
         E(6,7)=-0.22164568798978092980D+02
         E(6,8)=-0.43708444925702182337D+02
         E(6,9)= 0.56828128125398468990D+00
         SM(1)= 0.00000000000000000000D+00
         SM(2)= 0.10000000000000000000D+01
         SM(3)= 0.17500000000000000000D+01
         AM(1)= 0.58080578375796358720D+05
         AM(2)=-0.33214989339522861968D+05
         AM(3)= 0.28376088288312020853D+05
         AM(4)=-0.27923430684614999462D+05
         AM(5)= 0.29743005589491042677D+05
         AM(6)=-0.15525927919158826444D+05
         AM(7)=-0.27700591278076171875D+03
         AM(8)= 0.73086943817138671875D+03
         AM(9)= 0.00000000000000000000D+00
      END IF
C
            DO IS=1,NS
              C(IS)=HSTEP*C(IS)
              DO JS=1,NS
                A(IS,JS)=HSTEP*A(IS,JS)
              END DO
            END DO
            DO IM=1,NM
              DO IS=1,NS
                E(IS,NS+IM)=HSTEP*E(IS,NS+IM)
              END DO
              AM(NS+IM)=HSTEP*AM(NS+IM)
            END DO
      RETURN
      END
C -----------------------------------------------------------------


C -----------------------------------------------------------------
      SUBROUTINE WRITESOL (NR,tauOLD,tau,W,N,IRTRN)
C -----------------------------------------------------------------      
      IMPLICIT REAL*8 (A-H,O-Z)
      DIMENSION W(N)
      COMMON /INTERP/ANNN
        IF (NR.GE.ANNN) THEN
           write (6,*) W(1),W(2),W(3),W(4),W(5),W(6),W(7),W(8),tau
           ANNN=ANNN*1.01d0
        END IF
      RETURN
      END
C -----------------------------------------------------------------

