/* possible error messages for irkgaussMex */

/* general errors */
case 1:
  mexPrintf("Only two output argument is possible, but %i were requested.\n",
    i1);
  msg="Invalid number of output arguments";break;
case 2:
  mexPrintf("Only 3 or 4 input arguments are possible, but %i were passed.\n",
    i1);
  msg="Invalid number of input arguments";break;
case 3:
  mexPrintf("1st argument has characters, but needs to be ONE string. ");
  if (i1!=2) 
    mexPrintf("Not a 0-, 1- or >=3-dimensional thing.");
  else
    if (i2!=1) mexPrintf("Not a matrix containing strings.");
  mexPrintf("\n");
  msg="1. Arg: only ONE string expected";break;
case 4:
  mexPrintf("1st argument contained inline-funcs or function handles, but ");
  mexPrintf("I need only ONE. ");
  if (i1!=2)
    mexPrintf("Not a 0-, 1- or >=3-dimensional thing.");
  else
    if ((i2!=1) || (i3!=1)) 
      mexPrintf("Not a matrix containing inline-funcs or function handles.");
  mexPrintf("\n");
  msg="1. Arg: only ONE function expected";break;
case 5:
  mexPrintf("1st argument has to be a string (function name), ");
  mexPrintf("a function handle or an inline function.\n");
  msg="1. Arg: Function (String,handle,inline) expected";break;
case 6:
  mexPrintf("2nd argument has to be a double row vector.\n");
  msg="2. Arg: double row vector expected";break;
case 7:
  mexPrintf("2nd argument has to be a (1,2) double row vector. ");
  if (i1!=2)
    mexPrintf("Not a 0-, 1- or >=3-dimensional thing.");
  else
    if (i2!=1) mexPrintf("Not a double matrix.");
  mexPrintf("\n");
  msg="2. Arg: (1,2) double row vector expected";break;
case 8:
  mexPrintf("3rd argument has to be a double column vector.\n");
  msg="3. Arg: double vector expected";break;
case 9:
  mexPrintf("3rd argument has to be a double column vector. ");
  if (i1!=2)
    mexPrintf("Not a 0-, 1- or >=3-dimensional thing.");
  else
    if (i2!=2) mexPrintf("Not a double matrix.");
  mexPrintf("\n");
  msg="3. Arg: (d,1) double vector expected";break;
case 10:
  mexPrintf("3rd argument has to be a double column vector with at least\n");
  mexPrintf("one component.\n");
  msg="3. Arg: (d,1) double vector (d>=1) expected";break;
case 11:
  mexPrintf("4th argument has to be a struct.\n");
  msg="4. Arg: struct expected";break;
case 12:
  mexPrintf("Concerning Option '%s':\n",OPT_METHOD);
  mexPrintf("Valid values are 2,3,4,6, but I found %i.\n",i1);
  msg="Invalid method order";break;
case 13:
  mexPrintf("Concering Option '%s':\n",OPT_FUNCCALLMETHOD);
  mexPrintf("'%s'==0 was chosen. Hence all Matlab-functions must be given as string.\n",
    OPT_FUNCCALLMETHOD);
  mexPrintf("But the rightSide was not a string.\n");
  msg="CallMethod 0 => all Matlab-Funcs must be given as Strings";break;
case 14:
  mexPrintf("Concering Option '%s':\n",OPT_FUNCCALLMETHOD);
  mexPrintf("Requirement: '%s'==0 or '%s'==1\n",OPT_FUNCCALLMETHOD,OPT_FUNCCALLMETHOD);
  msg="Invalid call method";break;

/* errors concerning the right side */
case 301:
  mexPrintf("Problem calling the right side.\n");
  mexPrintf("No return values found.\n");
  msg="Right side without return values";break;
case 302:
  mexPrintf("Problem calling the right side.\n");
  mexPrintf("The return value was not a double-vector.\n");
  msg="Right side didn't return double vector";break;
case 303:
  mexPrintf("Problem calling the right side.\n");
  mexPrintf("The return value was neither a (d,1) nor a (1,d) double vector.\n");
  mexPrintf("I found a (%i,%i) double-matrix.\n",i1,i2);
  msg="Return value fo right side was not a (d,1) or (1,d) double vector";break;


/* errors that should never occur */
case 1001:
  msg="internal error: unknown funcCallMethod";break;
