function Y = paralfor(X)
global mu LagrangeDir PhSpGeoDir
LagrangeDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(LagrangeDir)
ext = X{1,1}; handles = X(1,2); Totalbar = X{1,3}; begin = X{1,4};
handles = handles{1,1};

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

if strcmp(ODE, 'Tom') == 1
    OutStep = str2num(get(handles.step_TOM,'String'));
elseif (strcmp(ODE, 'IRKGauss') == 1)
    OutStep = str2num(get(handles.step_IRK,'String'));
else
    OutStep = str2num(get(handles.step_ODE,'String'));
end

tau_total = str2num(get(handles.edit_time,'String'));
step_I1 = str2num(get(handles.step_1,'String'));
step_I2 = str2num(get(handles.step_2,'String'));
I1_init = str2num(get(handles.I1_in,'String'));
I2_init = str2num(get(handles.I2_in,'String'));
I1_final = str2num(get(handles.I1_fin,'String'));
I2_final = str2num(get(handles.I2_fin,'String'));
I3_o = str2num(get(handles.I3_o,'String'));
row_tot = step_I2 + 1;
col_tot = step_I1 + 1;
int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);

diagH
invT = inv(T);

q1_init = sqrt(2*I1_init);  p1_o = 0;
q2_init = sqrt(2*I2_init);  p2_o = 0;
q3_o = sqrt(2*I3_o);  p3_o = 0;

extstr = num2str(ext);
if row_tot <= col_tot   
    q1_o = sqrt(2*I1_init + 2*(I1_final-I1_init)/step_I1*(ext-1));
else
    q2_o = sqrt(2*I2_init + 2*(I2_final-I2_init)/step_I2*(ext-1));    
end

ccount = 0;
for int = 1:int_tot
    if row_tot <= col_tot
        q2_o = sqrt(2*I2_init + 2*(I2_final-I2_init)/step_I2*(int-1));        
    else
        q1_o = sqrt(2*I1_init + 2*(I1_final-I1_init)/step_I1*(int-1));
    end
    x1_o = 1/2*(q1_o-i*p1_o);  x2_o = 1/2*(q1_o+i*p1_o);
    x3_o = 1/2*(q2_o-i*p2_o);  x4_o = 1/2*(q2_o+i*p2_o);
    x5_o = 1/2*(q3_o-i*p3_o);  x6_o = 1/2*(q3_o+i*p3_o);
    x_o = [x1_o;  x2_o;  x3_o;  x4_o;  x5_o;  x6_o];
    X_o = T*x_o;
    X_o = X_o + [mu-1/2;  sqrt(3)/2;  0;  -sqrt(3)/2;  mu-1/2;  0];
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if strcmp(ODE, 'Tom') == 1
        met = str2num(get(handles.method_TOM,'String'));
        StepSize = str2num(get(handles.step_TOM,'String'));
        TomOutputStep = str2num(get(handles.step_TOM,'String'));
        RelTolNewt = str2num(get(handles.Rtn_TOM,'String'));
        Itnlmax = str2num(get(handles.ItMax_TOM,'String'));
        tom_options = tomgset('met',met,'Order',10,'StepSize',StepSize,...
            'RelTolNewt',RelTolNewt,...
            'Vectorized','off','OutputSteps',ceil(TomOutputStep/StepSize),...
            'Itnlmax',Itnlmax,'Stats_step','off','Stats','off');
        sol = tomgm('DiffEquation', [0 tau_total], X_o, tom_options);
        W = sol.y';
        tau = sol.x;
    elseif (strcmp(ODE, 'IRKGauss') == 1)
        opt.method = str2num(get(handles.method_IRK,'String'));
        opt.nstep = tau_total/OutStep;
        [tau,W] = eval([ODE, '(@DiffEquation, [0, tau_total], X_o, opt)']);
    else
        OutStep_string = num2str(OutStep);
        Rel_Tol = str2num(get(handles.RelTol,'String'));
        Abs_Tol = str2num(get(handles.AbsTol,'String'));
        Init_Step = str2num(get(handles.InStep,'String'));
        Max_Step = str2num(get(handles.step_ODE,'String'));
        options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
            'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);
        [tau,W] = eval([ODE, '(''DiffEquation'', [0 :',OutStep_string,': tau_total], X_o, options)']);
    end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    data_sep = num2str(2*pi*15915.7*OutStep);
    flag_FMFT = num2str(1);
    d = size(W(:,1),1);    
    ndata = num2str(2^(floor(log2(d))));
%%%%%%%%%%%%%%%%%%%%%
    W(:,1) = W(:,1)-mu+1/2;
    W(:,2) = W(:,2)-sqrt(3)/2;
    W(:,3) = W(:,3);
    W(:,4) = W(:,4)+sqrt(3)/2;
    W(:,5) = W(:,5)-mu+1/2;
    W(:,6) = W(:,6);
   
    WriteInput
%%%%%%%%%%%%%%%%%%%%%

%------------------- Frequencies ----------------------------------
    min_f = str2num(get(handles.freq1_min,'String'));
    max_f = str2num(get(handles.freq1_max,'String'));
    if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');
        nfreq = num2str(2);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_1)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(LagrangeDir)
            continue
        end        
        if abs(frq_1(1)) > 1
            freq_1(int) = frq_1(1);
        else
            freq_1(int) = frq_1(2);
        end
    else
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');         
        nfreq = num2str(1);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct1_',extstr,'.txt'],' ',['>FMFT_of_Act1_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_1] = textread(['FMFT_of_Act1_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_1)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(LagrangeDir)
            continue
        end          
        freq_1(int) = frq_1;
    end

    min_f = str2num(get(handles.freq2_min,'String'));
    max_f = str2num(get(handles.freq2_max,'String'));
    if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');
        nfreq = num2str(2);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_2)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(LagrangeDir)
            continue
        end          
        if abs(frq_2(1)) > 1
            freq_2(int) = frq_2(1);
        else
            freq_2(int) = frq_2(2);
        end
    else
        min_f = num2str(1000*min_f,'%6.12f');
        max_f = num2str(1000*max_f,'%6.12f');         
        nfreq = num2str(1);
        cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' ',['<inputAct2_',extstr,'.txt'],' ',['>FMFT_of_Act2_',extstr,'.txt']];  
        eval(cmd_string)
        [frq_2] = textread(['FMFT_of_Act2_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
        if numel(frq_2)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
            freq_1(int) = NaN;
            freq_min_1(int) = NaN;
            freq_max_1(int) = NaN;
            freq_2(int) = NaN;
            freq_min_2(int) = NaN;
            freq_max_2(int) = NaN;        
            freq_3(int) = NaN;
            freq_min_3(int) = NaN;
            freq_max_3(int) = NaN;
            cd(LagrangeDir)
            continue
        end          
        freq_2(int) = frq_2;
    end

    freq_3(int) = 0;        
    if str2num(get(handles.I3_o,'String')) ~= 0
        min_f = str2num(get(handles.freq3_min,'String'));
        max_f = str2num(get(handles.freq3_max,'String'));
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_3)== 0
            disp('Some error occurred: the corresponding frequency and FMI values will be left blank.')
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(LagrangeDir)
                continue
            end                     
            if abs(frq_3(1)) > 1
                freq_3(int) = frq_3(1);
            else
                freq_3(int) = frq_3(2);
            end          
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' ',['<inputAct3_',extstr,'.txt'],' ',['>FMFT_of_Act3_',extstr,'.txt']];  
            eval(cmd_string)
            [frq_3] = textread(['FMFT_of_Act3_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
            if numel(frq_3)== 0
                freq_1(int) = NaN;
                freq_min_1(int) = NaN;
                freq_max_1(int) = NaN;
                freq_2(int) = NaN;
                freq_min_2(int) = NaN;
                freq_max_2(int) = NaN;        
                freq_3(int) = NaN;
                freq_min_3(int) = NaN;
                freq_max_3(int) = NaN;
                cd(LagrangeDir)
                continue
            end                     
            freq_3(int) = frq_3;               
        end
    end
%-------------- Frequency Modulation Indicator (FMI)---------------
    str_FMFT_pick = num2str(FMFT_pick);                  
%----------------------- Freq1 ------------------------------------
    n_step = str2num(get(handles.Step_FMI1,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq1_min,'String')); 
        max_f = str2num(get(handles.freq1_max,'String'));        
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);                
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct1_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act1_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                freq(rr) = frq;
            end
        end

        freq_min_1(int) = min(freq);
        freq_max_1(int) = max(freq);

%       Set min FMI1 = -12        
        if abs((freq_max_1(int)-freq_min_1(int))/(freq_max_1(int)+freq_min_1(int))) < 1e-12
            freq_min_1(int) = 1;
            freq_max_1(int) = (1+1e-12)/(1-1e-12);
        end
    end
%--------------------- Freq2 -- -------------------------------
    n_step = str2num(get(handles.Step_FMI2,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq2_min,'String')); 
        max_f = str2num(get(handles.freq2_max,'String'));         
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct2_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act2_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                freq(rr) = frq;
            end
        end

        freq_min_2(int) = min(freq);
        freq_max_2(int) = max(freq);

%       Set min FMI2 = -12        
        if abs((freq_max_2(int)-freq_min_2(int))/(freq_max_2(int)+freq_min_2(int))) < 1e-12
            freq_min_2(int) = 1;
            freq_max_2(int) = (1+1e-12)/(1-1e-12);
        end           
    end
%--------------------- Freq3 ----------------------------------
    n_step = str2num(get(handles.Step_FMI3,'String'));
    if n_step >= 1
        min_f = str2num(get(handles.freq3_min,'String')); 
        max_f = str2num(get(handles.freq3_max,'String'));         
        if (sign(min_f) ~= sign(max_f) | min_f == 0 | max_f == 0)
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');
            nfreq = num2str(2);              
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string)
                [frq] = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                if abs(frq(1)) > 1
                    freq(rr) = frq(1);
                else
                    freq(rr) = frq(2);
                end
            end
        else
            min_f = num2str(1000*min_f,'%6.12f');
            max_f = num2str(1000*max_f,'%6.12f');         
            nfreq = num2str(1);
            for rr = 1:n_step + 1
                cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                    data_sep,' ',str_FMFT_pick,' ','<inputAct3_',num2str(rr),'_',extstr,'.txt',' ','>FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'];  
                eval(cmd_string) 
                frq = textread(['FMFT_of_Act3_',num2str(rr),'_',extstr,'.txt'], '%f %*f %*f', 'headerlines', 4);
                freq(rr) = frq;
            end
        end

        freq_min_3(int) = min(freq);
        freq_max_3(int) = max(freq);

%       Set min FMI3 = -12        
        if abs((freq_max_3(int)-freq_min_3(int))/(freq_max_3(int)+freq_min_3(int))) < 1e-12
            freq_min_3(int) = 1;
            freq_max_3(int) = (1+1e-12)/(1-1e-12);
        end
    end
%--------------------- End FMI --------------------------------------------
%---------------------------------------
    ccount = ccount + 1;
    perc = ccount/int_tot*100;
    fprintf('\n\n')
    if ccount == 1
        lgt = fprintf('\b\b%4.2f%%',perc);
    else
        fprintf(repmat('\b', 1, lgt));
        lgt = fprintf('%4.2f%%',perc) + 2;
    end
%---------------------------------------
    clear DiffEquation
end

n_step = str2num(get(handles.Step_FMI1,'String'));
if n_step >= 1
    FMI_1 = log10(abs((freq_max_1 - freq_min_1)./(freq_max_1 + freq_min_1)));
else
    FMI_1 = zeros(1, int_tot);
end

n_step = str2num(get(handles.Step_FMI2,'String'));
if n_step >= 1    
    FMI_2 = log10(abs((freq_max_2 - freq_min_2)./(freq_max_2 + freq_min_2)));
else
    FMI_2 = zeros(1, int_tot);
end

n_step = str2num(get(handles.Step_FMI3,'String'));
if n_step >= 1     
    FMI_3 = log10(abs((freq_max_3 - freq_min_3)./(freq_max_3 + freq_min_3)));
else
    FMI_3 = zeros(1, int_tot);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
compted = str2num(get(handles.count,'String'));
compted = compted + 1;
set(handles.count,'String', num2str(compted));

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = list{dim(1,1), dim(1,2)};

partial = str2num(get(handles.count,'String'));
total = max(row_tot, col_tot);
perc = partial/total;
completed = perc*100;

display('------------------------------------------------------------')
if row_tot <= col_tot
    display(['Column ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total column computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total'])
else
    display(['Row ',extstr,': computation completed at ', datestr(now)])
    display([curdir, ' -- Total row computed: ', get(handles.count,'String'),...
        ', equivalent to ',num2str(completed,'%4.2f'),'% of the total']) 
end
%%%%%%%%%%%%%%%% Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%
cd ..
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','a');
        fwrite(fid,'1');
        fclose(fid);
        failure = false;
    end
end
failure = true;
while failure
    try
        fid = fopen('WaitBar.txt','r');
        A = fread(fid,'*char');
        num = str2num(A);
        failure = false;
    end
end
perc = num2str(sum(num)/ext_tot*100,'%4.2f');

cd(LagrangeDir)
list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
curdir = list{dim(1,1), dim(1,2)};
update = [curdir,' - Total progress: ', perc, '%.',' Starting time: ', begin];

try
    waitbar(sum(num)/ext_tot, Totalbar, update);
catch ME
    % do nothing
end
%--------------------------------------------------------------------------
cd(LagrangeDir)
disp(['|============= Total progress: ',perc,'% ===============|']);
disp('    ')
%%%%%%%%%%%%%%%%%%%%%% End Total progress %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Y = [freq_1; freq_2; freq_3; FMI_1; FMI_2; FMI_3];
delete *.txt
