function varargout = Lagrange(varargin)
% LAGRANGE M-file for Lagrange.fig

% Last Modified by GUIDE v2.5 19-May-2015 22:44:23

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Lagrange_OpeningFcn, ...
    'gui_OutputFcn',  @Lagrange_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Lagrange is made visible.
function Lagrange_OpeningFcn(hObject, eventdata, handles, varargin)
global LagrangeDir PhSpGeoDir Eql
mu =  str2num(get(handles.edit_mass,'String'));
Eql = [mu-1/2   sqrt(3)/2  0  -sqrt(3)/2  mu-1/2  0];
LagrangeDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(LagrangeDir)
if isdeployed
    % do nothing
else
    path([PhSpGeoDir,'/AddedODEsolver/bin'], path);
    path([PhSpGeoDir,'/AddedODEsolver/TOM'], path);
    path([PhSpGeoDir,'/Util'], path);
    path([PhSpGeoDir,'/Util/Multicore'], path);
    path([LagrangeDir,'/Help'], path);
    path(LagrangeDir, path);
end
%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
      'HelpScript'];
set(handles.figure1,'HelpFcn',Hfcn);
cshelp(handles.figure1);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
              'set(gcbo,''CSHelpMode'',''off''); ' ...
          'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
              'set(gcbo,''CSHelpMode'',''on''); ' ...  
          'end'];     
set(handles.figure1,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
ColorFont   
handles.output = hObject;

if ~isnan(findstr(LagrangeDir, 'Slave'))
    set(handles.pushbutton_StartSlave, 'Visible', 'on')
    set(handles.pushbutton_Integrate, 'Enable', 'off')
    set(handles.pushbutton_Calculate, 'Visible', 'off')
else
    cd ..
    if exist('multicorefiles')
        rmdir('multicorefiles','s')
    end
    cd(LagrangeDir)
end

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
%curdir = list{dim(1,1), dim(1,2)};
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figure1, 'Name', curdir)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(LagrangeDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(LagrangeDir)
if get(handles.popupmenuODE,'Value') == 3
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'on')
    set(handles.opt_TOM, 'Visible', 'off')
elseif get(handles.popupmenuODE,'Value') == 6
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'off')
    set(handles.opt_TOM, 'Visible', 'on')    
end

if str2num(get(handles.I3_o,'String')) == 0
    set(handles.Step_FMI3,'Enable','off')
else
    set(handles.Step_FMI3,'Enable','on')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(LagrangeDir, 'Slave'))
    Totalbar = waitbar(0,'Please wait..., LAGRANGE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Lagrange_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
global LagrangeDir PhSpGeoDir
if ~isnan(findstr(LagrangeDir, 'Slave'))
%do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on')     
        cd(LagrangeDir)
        InitStructure
        cd ..        
        save('Setting.mat', '-struct', 'InitStr')
        cd(LagrangeDir)
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 Choose equilibrium point
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on selection change in popupmenu_Eql.
function popupmenu_Eql_Callback(hObject, eventdata, handles)
item = get(hObject,'Value');
if item == 1
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 2
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 3
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 4;
    set(handles.uipanel_FMI,'Visible','on');
elseif item == 5;
    set(handles.uipanel_FMI,'Visible','off');
end
Disable_all
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Single orbit analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_mass_Callback(hObject, eventdata, handles)
Disable_all
%{
mu =  str2num(get(handles.edit_mass,'String'));
omega1 = sqrt((1+sqrt(1-27*mu+27*mu^2))/2)
omega2 = -sqrt((1-sqrt(1-27*mu+27*mu^2))/2)
omega3 = 1
%}
function edit_time_Callback(hObject, eventdata, handles)
Disable_all

function q1_o_Callback(hObject, eventdata, handles)
Disable_all

function q2_o_Callback(hObject, eventdata, handles)
Disable_all

function q3_o_Callback(hObject, eventdata, handles)
Disable_all

function p1_o_Callback(hObject, eventdata, handles)
Disable_all

function p2_o_Callback(hObject, eventdata, handles)
Disable_all

function p3_o_Callback(hObject, eventdata, handles)
Disable_all

% --- Executes on button press in pushbutton_Integrate.
function pushbutton_Integrate_Callback(hObject, eventdata, handles)
global mu time Eql X tau
mu =  str2num(get(handles.edit_mass,'String'));
time = str2num(get(handles.edit_time,'String'));
opts = optimset('Display','off','TolX',eps);
item = get(handles.popupmenu_Eql,'Value');
if item == 1
    f = @(x)x + (1-mu)/(x-mu)^2 - mu/(x-mu+1)^2;  
    xeq = fzero(f, mu-1/2, opts);
    Eql = [xeq  0  0  0  xeq  0];
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 2
    f = @(x)x + (1-mu)/(x-mu)^2 + mu/(x-mu+1)^2;
    xeq = fzero(f, 1.1*(mu-1), opts);
    Eql = [xeq  0  0  0  xeq  0];
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 3
    f = @(x)x - (1-mu)/(x-mu)^2 - mu/(x-mu+1)^2;
    xeq = fzero(f, 1.1*mu, opts);
    Eql = [xeq  0  0  0  xeq  0];
    set(handles.uipanel_FMI,'Visible','off');
elseif item == 4;
    Eql = [mu-1/2   sqrt(3)/2  0  -sqrt(3)/2  mu-1/2  0];
    set(handles.uipanel_FMI,'Visible','on');
elseif item == 5;
    Eql = [mu-1/2  -sqrt(3)/2  0   sqrt(3)/2  mu-1/2  0];
    set(handles.uipanel_FMI,'Visible','off');
end

deltax = str2num(get(handles.q1_o,'String'));
deltay = str2num(get(handles.q2_o,'String'));
deltaz = str2num(get(handles.q3_o,'String'));
vx = str2num(get(handles.p1_o,'String'));
vy = str2num(get(handles.p2_o,'String'));
vz = str2num(get(handles.p3_o,'String'));

q1 = Eql(1) + deltax;
q2 = Eql(2) + deltay;
q3 = Eql(3) + deltaz;
p1 = Eql(4) - deltay + vx;
p2 = Eql(5) + deltax + vy;
p3 = Eql(6) + vz;

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));

global pick                                                %%%%%     waitbar
h = waitbar(0,'Please wait..., LAGRANGE is calculating.'); %%%%%     waitbar
pick = -time/100;                                          %%%%%     waitbar
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(h)
        return
    end
%-----------------------------
%-------------------------------------------------------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Tom
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if strcmp(ODE, 'Tom') == 1
    met = str2num(get(handles.method_TOM,'String'));
    StepSize = str2num(get(handles.step_TOM,'String'));
    TomOutputStep = str2num(get(handles.step_TOM,'String'));
    RelTolNewt = str2num(get(handles.Rtn_TOM,'String'));
    Itnlmax = str2num(get(handles.ItMax_TOM,'String'));

    tom_options = tomgset('met',met,'Order',10,'StepSize',StepSize,...
        'RelTolNewt',RelTolNewt,...
        'Vectorized','off','OutputSteps',ceil(TomOutputStep/StepSize),...
        'Itnlmax',Itnlmax,'Stats_step','off','Stats','off');

    sol = tomgm('DiffEquation', [0 time], [q1; q2; q3; p1; p2; p3], tom_options);
    X = sol.y';
    X = X';
    tau = sol.x;
    set(handles.pushbutton_Orbits, 'Enable', 'on')
    set(handles.pushbutton_AA, 'Enable', 'on')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    IRK-Gauss
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
elseif (strcmp(ODE, 'IRKGauss') == 1)
    StepSize = str2num(get(handles.step_IRK,'String'));
    opt.method = str2num(get(handles.method_IRK,'String'));    
    opt.nstep = time/StepSize;
    [tau,X] = eval([ODE, '(@DiffEquation, [0, time], [q1; q2; q3; p1; p2; p3], opt)']);       
    X = X';
    set(handles.pushbutton_Orbits, 'Enable', 'on')
    set(handles.pushbutton_AA, 'Enable', 'on')
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                Other ODE solvers
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
else
    Rel_Tol = str2num(get(handles.RelTol,'String'));
    Abs_Tol = str2num(get(handles.AbsTol,'String'));
    Init_Step = str2num(get(handles.InStep,'String'));
    Max_Step = str2num(get(handles.step_ODE,'String'));
    OutStep = get(handles.step_ODE,'String');
    if isempty(OutStep)
        set(handles.edit_OutputStep,'String','0.01');
        OutStep = '0.01';
        Output_Step = [':',OutStep,':'];
    else
        Output_Step = [':',OutStep,':'];
    end

    options = odeset('InitialStep',[Init_Step], 'Maxstep',[Max_Step],...
        'RelTol',[Rel_Tol], 'AbsTol',[Abs_Tol]);

    [tau,X] = eval([ODE, '(''DiffEquation'', [0 ',Output_Step,'time], [q1; q2; q3; p1; p2; p3], options)']);
    X = X';
    set(handles.pushbutton_Orbits, 'Enable', 'on')
    item = get(handles.popupmenu_Eql,'Value');
    if item == 4;
        set(handles.pushbutton_AA, 'Enable', 'on')
    end
end
close(h);
%-------------------------------------------------------------------------
% --- Executes on button press in pushbutton_Orbits.
function pushbutton_Orbits_Callback(hObject, eventdata, handles)
global X mu Eql

figure
hold on
plot3(X(1,:),X(2,:),X(3,:));
plot3(mu-1,0,0,'-mo','MarkerFaceColor',[0.6  0.6  0.6],'MarkerSize',20*(mu)^(1/3))
plot3(mu,0,0,'-mo','MarkerFaceColor','b','MarkerSize',20*(1-mu)^(1/3))
plot3(Eql(1), Eql(2), 0, '-*r', 'MarkerSize',14);
grid off
axis equal
title('Space trajectory','FontSize',14)
xlabel('\itx', 'FontSize',14)
ylabel('\ity', 'FontSize',14)
zlabel('\itz', 'FontSize',14)

figure
plot3(X(4,:)+X(2), X(5,:)-X(1), X(6,:));
title('Relative velocity trajectory','FontSize',14)
xlabel('\itv_x', 'FontSize',14)
ylabel('\itv_y', 'FontSize',14)
zlabel('\itv_z', 'FontSize',14)

% --- Executes on button press in pushbutton_AA.
function pushbutton_AA_Callback(hObject, eventdata, handles)
global mu X tau
Y = [X(1,:)-mu+1/2; X(2,:)-sqrt(3)/2; X(3,:); X(4,:)+sqrt(3)/2; X(5,:)-mu+1/2; X(6,:)];
diagH
x = inv(T)*Y;

q1 = x(1,:) + x(2,:);   p1 = i*(x(1,:) - x(2,:));

I1 = 1/2*real(q1.*q1 + p1.*p1);
figure
plot(tau,I1)
title('First Action','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\itI_1', 'FontSize',14)

phi1 = -180/pi*atan2(real(p1),real(q1));
figure
plot(tau,phi1)
title('First Angle','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\it\phi_1 \rm(degrees)', 'FontSize',14)

q2 = x(3,:) + x(4,:);   p2 = i*(x(3,:) - x(4,:));

I2 = 1/2*real(q2.*q2 + p2.*p2);
figure
plot(tau,I2)
title('Second Action','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\itI_2', 'FontSize',14)

phi2 = 180/pi*atan2(real(p2),real(q2));
figure
plot(tau,phi2)
title('Second Angle','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\it\phi_2 \rm(degrees)', 'FontSize',14)

q3 = x(5,:) + x(6,:);   p3 = i*(x(5,:) - x(6,:));

I3 = 1/2*real(q3.*q3 + p3.*p3);
figure
plot(tau,I3)
title('Third Action','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\itI_3', 'FontSize',14)

phi3 = -180/pi*atan2(real(p3),real(q3));
figure
plot(tau,phi3)
title('Third Angle','FontSize',14)
xlabel('\ittime', 'FontSize',14)
ylabel('\it\phi_3 \rm(degrees)', 'FontSize',14)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                               ODE solver
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popupmenuODE_Callback(hObject, eventdata, handles)
Disable_all
contents = get(hObject,'String');
item = get(hObject,'Value');
ODE = char(contents(item));
if strcmp(ODE, 'Tom') == 1
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'off')
    set(handles.opt_TOM, 'Visible', 'on')  
elseif  (strcmp(ODE, 'IRKGauss') == 1)   
    set(handles.opt_ODE, 'Visible', 'off')
    set(handles.opt_IRK, 'Visible', 'on')
    set(handles.opt_TOM, 'Visible', 'off')
else
    set(handles.opt_ODE, 'Visible', 'on')
    set(handles.opt_IRK, 'Visible', 'off')
    set(handles.opt_TOM, 'Visible', 'off')
end

function RelTol_Callback(hObject, eventdata, handles)
Disable_all

function AbsTol_Callback(hObject, eventdata, handles)
Disable_all

function InStep_Callback(hObject, eventdata, handles)
Disable_all

function MaxStep_Callback(hObject, eventdata, handles)
Disable_all

function step_ODE_Callback(hObject, eventdata, handles)
Disable_all

function step_IRK_Callback(hObject, eventdata, handles)
Disable_all

function method_IRK_Callback(hObject, eventdata, handles)
Disable_all

function step_TOM_Callback(hObject, eventdata, handles)
Disable_all

function Rtn_TOM_Callback(hObject, eventdata, handles)
Disable_all

function ItMax_TOM_Callback(hObject, eventdata, handles)
Disable_all

function method_TOM_Callback(hObject, eventdata, handles)
Disable_all

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                           Frequency analysis
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function I1_in_Callback(hObject, eventdata, handles)
Disable_all

function I1_fin_Callback(hObject, eventdata, handles)
Disable_all

function step_1_Callback(hObject, eventdata, handles)
Disable_all
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end

function I2_in_Callback(hObject, eventdata, handles)
Disable_all

function I2_fin_Callback(hObject, eventdata, handles)
Disable_all

function step_2_Callback(hObject, eventdata, handles)
Disable_all
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end

function I3_o_Callback(hObject, eventdata, handles)
Disable_all
if str2num(get(handles.I3_o,'String')) == 0
    set(handles.Step_FMI3,'Enable','off')
else
    set(handles.Step_FMI3,'Enable','on')
end

function freq1_min_Callback(hObject, eventdata, handles)
Disable_all

function freq1_max_Callback(hObject, eventdata, handles)
Disable_all

function freq2_min_Callback(hObject, eventdata, handles)
Disable_all

function freq2_max_Callback(hObject, eventdata, handles)
Disable_all

function freq3_min_Callback(hObject, eventdata, handles)
Disable_all

function freq3_max_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI1_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI2_Callback(hObject, eventdata, handles)
Disable_all

function Step_FMI3_Callback(hObject, eventdata, handles)
Disable_all

% --- Executes on button press in pushbutton_Calculate.
function pushbutton_Calculate_Callback(hObject, eventdata, handles)
Disable_all
global LagrangeDir mu freq_1 freq_2 freq_3 FMI_1 FMI_2 FMI_3 I1 I2
mu = str2num(get(handles.edit_mass,'String'));

step_I1 = str2num(get(handles.step_1,'String'));
step_I2 = str2num(get(handles.step_2,'String'));
I1_init = str2num(get(handles.I1_in,'String'));
I2_init = str2num(get(handles.I2_in,'String'));
I1_final = str2num(get(handles.I1_fin,'String'));
I2_final = str2num(get(handles.I2_fin,'String'));
I3 = str2num(get(handles.I3_o,'String'));
row_tot = step_I2 + 1;
col_tot = step_I1 + 1;
int_tot = min(row_tot, col_tot);
ext_tot = max(row_tot, col_tot);

diagH
invT = inv(T);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
if ~isnan(findstr(LagrangeDir, 'Slave'))
% do nothing
else
    Totalbar = waitbar(0,'Please wait..., LAGRANGE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end

contents = get(handles.popupmenuODE,'String');
item = get(handles.popupmenuODE,'Value');
ODE = char(contents(item));
%-----------------------------
    if strcmp(mexext,'mexw64') & (strcmp(ODE,'IRKGauss') | strcmp(ODE,'Dop853') | strcmp(ODE,'Odex'))
        display('This ODE solver method is not available for 64-bit version of MATLAB')
        close(Totalbar)
        return
    end
%-----------------------------
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display(['    STARTING COMPUTATION with ',ODE,'!!!'])
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,4);
for ext = 1:ext_tot
    subcell{1,1} =  [ext];
    subcell{1,2} = [handles];
    subcell{1,3} = [Totalbar];
    subcell{1,4} = [begin];      
    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(LagrangeDir)

warning('off')
resultCell = startmulticoremaster(@paralfor, parameterCell, '../multicorefiles');
warning('on')
%---------------------- End multicore -----------------------------------
freq_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    freq_1 = [freq_1; resultCell{1,k}(1,:)];
end
freq_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    freq_2 = [freq_2; resultCell{1,k}(2,:)];
end
freq_3 = [resultCell{1,1}(3,:)];
for k = 2 : ext_tot
    freq_3 = [freq_3; resultCell{1,k}(3,:)];
end
FMI_1 = [resultCell{1,1}(4,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(4,:)];
end
FMI_2 = [resultCell{1,1}(5,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(5,:)];
end
FMI_3 = [resultCell{1,1}(6,:)];
for k = 2 : ext_tot
    FMI_3 = [FMI_3; resultCell{1,k}(6,:)];
end

if row_tot <= col_tot
    freq_1 = freq_1';
    freq_2 = freq_2';
    freq_3 = freq_3';
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
    FMI_3 = FMI_3';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    save freq1.dat freq_1 -ascii
    save freq2.dat freq_2 -ascii
    save freq3.dat freq_3 -ascii
    save FMI1.dat FMI_1 -ascii
    save FMI2.dat FMI_2 -ascii
    save FMI3.dat FMI_3 -ascii
    delete *.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
set(handles.pushbutton_freq, 'Enable', 'on')
set(handles.pushbutton_level, 'Enable', 'on')
set(handles.pushbutton_FMI, 'Enable', 'on')
set(handles.pushbutton_ratio, 'Enable', 'on')
I1 = I1_init : (I1_final - I1_init)/(col_tot - 1) : I1_final;
I2 = I2_init : (I2_final - I2_init)/(row_tot - 1) : I2_final;

display('-------------------------------------------------------------------')
display(['            FINISH with ',ODE,'!!!'])
toc
display('###################################################################')
set(handles.count,'String', '0');

% --- Executes on button press in pushbutton_freq.
function pushbutton_freq_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
figure
colormap(gray)
surfc(I1, I2, freq_1, 'FaceColor', 'interp', 'LineStyle', ':');
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 1', 'FontSize',14)

figure
colormap(gray)
surfc(I1, I2, freq_2, 'FaceColor', 'interp', 'LineStyle', ':');
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 2', 'FontSize',14)

figure
colormap(gray)
surfc(I1, I2, freq_3, 'FaceColor', 'interp', 'LineStyle', ':');
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 3', 'FontSize',14)

% --- Executes on button press in pushbutton_level.
function pushbutton_level_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
figure
[C,h] = contour(I1,I2, freq_1);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 1', 'FontSize',14)

figure
[C,h] = contour(I1,I2, freq_2);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 2', 'FontSize',14)

figure
[C,h] = contour(I1,I2, freq_3);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title('Frequency 3', 'FontSize',14)

% --- Executes on button press in pushbutton_FMI.
function pushbutton_FMI_Callback(hObject, eventdata, handles)
global FMI_1 FMI_2 FMI_3 I1 I2
if str2num(get(handles.Step_FMI1,'String')) > 0;
    figure
    colormap(gray)
    surf(I1, I2, FMI_1, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'FMI 1'}, 'FontSize',14)
end

if str2num(get(handles.Step_FMI2,'String')) > 0;
    figure
    colormap(gray)
    surf(I1, I2, FMI_2, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'FMI 2'}, 'FontSize',14)
end

if str2num(get(handles.Step_FMI3,'String')) > 0;
    figure
    colormap(gray)
    surf(I1, I2, FMI_3, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'FMI 3'}, 'FontSize',14)
end


% --- Executes on button press in pushbutton_ratio.
function pushbutton_ratio_Callback(hObject, eventdata, handles)
global freq_1 freq_2 freq_3 I1 I2
freq_ratio_12(:,:) = abs(freq_1(:,:)./freq_2(:,:));
if str2num(get(handles.I3_o,'String')) ~= 0
    freq_ratio_13(:,:) = abs(freq_1(:,:)./freq_3(:,:));
    freq_ratio_32(:,:) = abs(freq_3(:,:)./freq_2(:,:));
end
figure
[C,h] = contour(I1,I2, freq_ratio_12);
clabel(C,h);
xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
title({'Level lines of the Frequency 1 over 2'}, 'FontSize',14)
if str2num(get(handles.I3_o,'String')) ~= 0    
    figure
    [C,h] = contour(I1,I2, freq_ratio_13);
    clabel(C,h);
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'Level lines of the Frequency 1 over 3'}, 'FontSize',14)    

    figure
    [C,h] = contour(I1,I2, freq_ratio_32);
    clabel(C,h);
    xlabel('\itI_1', 'FontSize',14), ylabel('\itI_2', 'FontSize',14)
    title({'Level lines of the Frequency 3 over 2'}, 'FontSize',14)
end

% --- Executes on button press in pushbutton_StartSlave.
function pushbutton_StartSlave_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)
global mu
mu = str2num(get(handles.edit_mass,'String'));
startmulticoreslave('../multicorefiles')

%%%%%%%%%%%%%%%%%%% MENU %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function savesetting_Callback(hObject, eventdata, handles)
% do nothing

function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Save_now_Callback(hObject, eventdata, handles)
global LagrangeDir PhSpGeoDir
InitStructure
cd(LagrangeDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(LagrangeDir)

function save_fig_Callback(hObject, eventdata, handles)
if isempty(get(0,'CurrentFigure'))
%    set(handles.save_eps,'Enable','off')
    set(handles.save_pdf,'Enable','off')
    set(handles.save_png,'Enable','off')
    set(handles.jpeg2eps,'Enable','off')
else
%    set(handles.save_eps,'Enable','on')
    set(handles.save_pdf,'Enable','on')
    set(handles.save_png,'Enable','on')
    set(handles.jpeg2eps,'Enable','on')
end
%{
function save_eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'eps', '-fonts')   
else
    savfig(name, 'eps', '-fonts')
end
%}
function save_pdf_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'pdf', '-fonts')   
else
    savfig(name, 'pdf', '-fonts')
end

function save_png_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'png', '-r1200')   
else
    savfig(name, 'png', '-r1200')
end

function jpeg2eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
global PhSpGeoDir
if strcmp(name, '')
    savfig('CurrentFigure', 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 CurrentFigure.jpeg > CurrentFigure.eps'];
    eval(cmd_string)
else
    savfig(name, 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 ',name,'.jpeg > ',name,'.eps'];
    eval(cmd_string)    
end


function Help_Callback(hObject, eventdata, handles)
% do nothing

function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','on');

function EscHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','off');

function About_Callback(hObject, eventdata, handles)
About

function Credits_Callback(hObject, eventdata, handles)
Credits

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%% END of CODE %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
