function varargout = Laplace(varargin)
% LAPLACE M-save_now for Laplace.fig

% Last Modified by GUIDE v2.5 25-Dec-2020 17:52:46

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Laplace_OpeningFcn, ...
    'gui_OutputFcn',  @Laplace_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before Laplace is made visible.
function Laplace_OpeningFcn(hObject, eventdata, handles, varargin)
format('long')
delete *.dat *.dmp *.tmp *.out *.txt *.aei *.asv
if exist('custom.hnb','file')
    delete('custom.hnb')
end
if exist('big.in','file')
    delete('big.in')
end
if exist('small.in','file')
    delete('small.in')
end
if exist('param.in','file')
    delete('param.in')
end
if exist('element.in','file')
    delete('element.in')
end
global LaplaceDir PhSpGeoDir
LaplaceDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(LaplaceDir)
if isdeployed
    %do nothing
else
    path([LaplaceDir,'/NormalForm'], path);
    path([PhSpGeoDir,'/Util'], path);
    path([PhSpGeoDir,'/Util/Multicore'], path);
    path([LaplaceDir,'/Help'], path);
    path(LaplaceDir, path);
end
%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
      'HelpScript'];
set(handles.figure1,'HelpFcn',Hfcn);
cshelp(handles.figure1);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
              'set(gcbo,''CSHelpMode'',''off''); ' ...
          'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
              'set(gcbo,''CSHelpMode'',''on''); ' ...  
          'end'];     
set(handles.figure1,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(LaplaceDir, 'Slave'))
    set(handles.pushbutton_StartSlave, 'Visible', 'on','Enable', 'on')
    set(handles.pushbutton_Integrate, 'Enable', 'off')
    set(handles.pushbutton_Calculate, 'Visible', 'off')
else
    multicoredir = tempdir2;
    if exist(strcat(multicoredir,'/multicorefiles'))
        rmdir(strcat(multicoredir,'/multicorefiles'),'s')
    end
end

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
%curdir = list{dim(1,1), dim(1,2)};
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figure1, 'Name', curdir)

ColorFont

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(LaplaceDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(LaplaceDir)
SetPlanet

if str2num(get(handles.edit_intstep,'String')) == 0
    set(handles.edit_intto,'Enable','off')
%    uibutton(handles.uipanel10,'Style','text','Interpreter','LaTex','String','$=$','FontSize',12,...
%    'BackgroundColor',[0.925  0.914  0.847],'Position',[256 33 20 20])
else
    set(handles.edit_intto,'Enable','on')
%    uibutton(handles.uipanel10,'Style','text','Interpreter','LaTex','String','$\leq$','FontSize',12,...
%    'BackgroundColor',[0.925  0.914  0.847],'Position',[256 33 20 20])
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%{
if ~isnan(findstr(LaplaceDir, 'Slave'))
    Totbar = waitbar(0,'Please wait..., LAPLACE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end
%}
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Choose default command line output for Laplace
handles.output = hObject;

% Update handles structure
guidata(hObject, handles);

% --- Outputs from this function are returned to the command line.
function varargout = Laplace_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Save on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
format('short')
global LaplaceDir PhSpGeoDir

if ~isnan(findstr(LaplaceDir, 'Slave'))
    %do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on') & LaplaceDir
        cd(LaplaceDir)
        InitStructure
        cd ..
        save('Setting.mat', '-struct', 'InitStr')
        cd(LaplaceDir)
    end
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               1st Panel: Initial conditions
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function edit_mass1_Callback(hObject, eventdata, handles)
DisableAll
mass1 = get(handles.edit_mass1,'String');
if mass1
    list = get(handles.popupmenu_planet,'String');
    list(1) = {'Mercury'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end
    set(handles.text1,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(1) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end
    set(handles.text1,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass2_Callback(hObject, eventdata, handles)
DisableAll
mass2 = get(handles.edit_mass2,'String');
if mass2
    list = get(handles.popupmenu_planet,'String');
    list(2) = {'Venus'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text2,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(2) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text2,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass3_Callback(hObject, eventdata, handles)
DisableAll
mass3 = get(handles.edit_mass3,'String');
if mass3
    list = get(handles.popupmenu_planet,'String');
    list(3) = {'Earth-Moon'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text3,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(3) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text3,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass4_Callback(hObject, eventdata, handles)
DisableAll
mass4 = get(handles.edit_mass4,'String');
if mass4
    list = get(handles.popupmenu_planet,'String');
    list(4) = {'Mars'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text4,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(4) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text4,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass5_Callback(hObject, eventdata, handles)
DisableAll
mass5 = get(handles.edit_mass5,'String');
if mass5
    list = get(handles.popupmenu_planet,'String');
    list(5) = {'Asteroid'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text5,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(5) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text5,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass6_Callback(hObject, eventdata, handles)
DisableAll
mass6 = get(handles.edit_mass6,'String');
if mass6
    list = get(handles.popupmenu_planet,'String');
    list(6) = {'Jupiter'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text6,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(6) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text6,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass7_Callback(hObject, eventdata, handles)
DisableAll
mass7 = get(handles.edit_mass7,'String');
if mass7
    list = get(handles.popupmenu_planet,'String');
    list(7) = {'Saturn'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text7,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(7) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text7,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass8_Callback(hObject, eventdata, handles)
DisableAll
mass8 = get(handles.edit_mass8,'String');
if mass8
    list = get(handles.popupmenu_planet,'String');
    list(8) = {'Uranus'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text8,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(8) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text8,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass9_Callback(hObject, eventdata, handles)
DisableAll
mass9 = get(handles.edit_mass9,'String');
if mass9
    list = get(handles.popupmenu_planet,'String');
    list(9) = {'Neptune'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text9,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(9) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text9,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_mass10_Callback(hObject, eventdata, handles)
DisableAll
mass10 = get(handles.edit_mass10,'String');
if mass10
    list = get(handles.popupmenu_planet,'String');
    list(10) = {'Pluto'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text10,'Visible','on')
else
    list = get(handles.popupmenu_planet,'String');
    list(10) = {'Absent'};
    set(handles.popupmenu_planet,'String',list);
    set(handles.popupmenu_planetFMI_ext,'String',list);
    set(handles.popupmenu_planetFMI_int,'String',list);
    for rr = 1:9
        rr = num2str(rr);
        P_rr = ['set(handles.popupmenu_P', rr, ',''String'',list)'];
        eval(P_rr)
    end    
    set(handles.text10,'Visible','off')
end
%--------------------------------------------------------------------------
function edit_sma1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_sma10_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_ecc10_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_incl10_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_asc10_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_peri10_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean1_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean2_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean3_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean4_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean5_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean6_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean7_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean8_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean9_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_longmean10_Callback(hObject, eventdata, handles)
DisableAll

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                       2nd panel: Integration
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function popupmenu_ODE_Callback(hObject, eventdata, handles)
DisableAll
if get(handles.popupmenu_ODE,'Value') < 4;
    set(handles.PostNewton,'Enable','on');
else
    set(handles.PostNewton,'Enable','off');
end
%--------------------------------------------------------------------------
function PostNewton_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_integstep_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_totint_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_outstep_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function pushbutton_Integrate_Callback(hObject, eventdata, handles)
set(handles.pushbutton_Integrate,'Enable','off')
DisableAll
delete *.dat *.dmp *.tmp *.out
global jumprow planet
planet = get(handles.popupmenu_planet,'String');
global LaplaceDir
cd(LaplaceDir)

N = 10;
for k = 1:10
    if strcmp(planet(k),'Absent')
        N = N-1;
    end
end

for k = 1:N
    while strcmp(planet(k),'Absent')
        planet(k) = '';   
    end
end

while size(planet,1) > N
    planet(N+1) = '';
end

%%%%%%%%%%%%%%%%%%%% Mercury %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass1   = get(handles.edit_mass1,'String');
sma1    = get(handles.edit_sma1,'String');
ecc1    = get(handles.edit_ecc1,'String');
incl1   = get(handles.edit_incl1,'String');
asc1    = get(handles.edit_asc1,'String');
peri1    = get(handles.edit_peri1,'String');
longmean1 = get(handles.edit_longmean1,'String');
%%%%%%%%%%%%%%%%%%%% Venus %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass2   = get(handles.edit_mass2,'String');
sma2    = get(handles.edit_sma2,'String');
ecc2    = get(handles.edit_ecc2,'String');
incl2   = get(handles.edit_incl2,'String');
asc2    = get(handles.edit_asc2,'String');
peri2    = get(handles.edit_peri2,'String');
longmean2 = get(handles.edit_longmean2,'String');
%%%%%%%%%%%%%%%%%%%% Earth-Moon %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass3   = get(handles.edit_mass3,'String');
sma3    = get(handles.edit_sma3,'String');
ecc3    = get(handles.edit_ecc3,'String');
incl3   = get(handles.edit_incl3,'String');
asc3    = get(handles.edit_asc3,'String');
peri3    = get(handles.edit_peri3,'String');
longmean3 = get(handles.edit_longmean3,'String');
%%%%%%%%%%%%%%%%%%%%% Mars %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass4   = get(handles.edit_mass4,'String');
sma4    = get(handles.edit_sma4,'String');
ecc4    = get(handles.edit_ecc4,'String');
incl4   = get(handles.edit_incl4,'String');
asc4    = get(handles.edit_asc4,'String');
peri4    = get(handles.edit_peri4,'String');
longmean4 = get(handles.edit_longmean4,'String');
%%%%%%%%%%%%%%%%%%%% Asteroid %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass5   = get(handles.edit_mass5,'String');
sma5    = get(handles.edit_sma5,'String');
ecc5    = get(handles.edit_ecc5,'String');
incl5   = get(handles.edit_incl5,'String');
asc5    = get(handles.edit_asc5,'String');
peri5    = get(handles.edit_peri5,'String');
longmean5 = get(handles.edit_longmean5,'String');
%%%%%%%%%%%%%%%%%%%% Jupiter %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass6   = get(handles.edit_mass6,'String');
sma6    = get(handles.edit_sma6,'String');
ecc6    = get(handles.edit_ecc6,'String');
incl6   = get(handles.edit_incl6,'String');
asc6    = get(handles.edit_asc6,'String');
peri6    = get(handles.edit_peri6,'String');
longmean6 = get(handles.edit_longmean6,'String');
%%%%%%%%%%%%%%%%%%%% Saturn %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass7   = get(handles.edit_mass7,'String');
sma7    = get(handles.edit_sma7,'String');
ecc7    = get(handles.edit_ecc7,'String');
incl7   = get(handles.edit_incl7,'String');
asc7    = get(handles.edit_asc7,'String');
peri7    = get(handles.edit_peri7,'String');
longmean7 = get(handles.edit_longmean7,'String');
%%%%%%%%%%%%%%%%%%%% Uranus %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass8   = get(handles.edit_mass8,'String');
sma8    = get(handles.edit_sma8,'String');
ecc8    = get(handles.edit_ecc8,'String');
incl8   = get(handles.edit_incl8,'String');
asc8    = get(handles.edit_asc8,'String');
peri8    = get(handles.edit_peri8,'String');
longmean8 = get(handles.edit_longmean8,'String');
%%%%%%%%%%%%%%%%%%%% Neptune %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass9   = get(handles.edit_mass9,'String');
sma9    = get(handles.edit_sma9,'String');
ecc9    = get(handles.edit_ecc9,'String');
incl9   = get(handles.edit_incl9,'String');
asc9    = get(handles.edit_asc9,'String');
peri9    = get(handles.edit_peri9,'String');
longmean9 = get(handles.edit_longmean9,'String');
%%%%%%%%%%%%%%%%%%%% Pluto %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
mass10   = get(handles.edit_mass10,'String');
sma10    = get(handles.edit_sma10,'String');
ecc10    = get(handles.edit_ecc10,'String');
incl10   = get(handles.edit_incl10,'String');
asc10    = get(handles.edit_asc10,'String');
peri10    = get(handles.edit_peri10,'String');
longmean10 = get(handles.edit_longmean10,'String');
%%%%%%%%%%%%%%%%% ODE integration %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
item = get(handles.popupmenu_ODE,'Value');
if item == 1;
    Method = 'Symplectic';
elseif item == 2;
    Method = 'Bulirsch-Stoer';
elseif item == 3;
    Method = 'Runge-Kutta';
elseif item == 4;
    Method = 'MVS';
elseif item == 5;
    Method = 'Radau';
elseif item == 6;
    Method = 'BS2';
elseif item == 7;
    Method = 'Hybrid';
end

integstep = get(handles.edit_integstep,'String');
totint = get(handles.edit_totint,'String');
outstep = get(handles.edit_outstep,'String');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if item < 4
    jumprow = 17;
    fid = fopen( 'custom.hnb', 'wt');
    fprintf(fid, ['Integrator: ',Method,'\n']);
    %{
    if item == 1
        fprintf(fid,'IntegCoord = Jacobi Order2 Kick-Drift\n');
    else
        fprintf(fid,'IntegCoord = Bodycentric Order2 Kick-Drift\n');
    end
    %}
    fprintf(fid, ['StepSize: ',integstep,'\n']);
    fprintf(fid, ['Tfinal: ',totint,'\n']);
    fprintf(fid, ['OutputInterval: ',outstep,'\n']);
    fprintf(fid, ['EnergyInterval: ',num2str(100*str2num(outstep)),'\n']);
    if get(handles.PostNewton, 'Value') == 1;
        fprintf(fid,'PostNewtonian = True\n');
    end

    if mass1
        fprintf(fid, [mass1,'   ',sma1,'   ',ecc1,'   ',incl1,'   ',asc1,'   ',peri1,'   ',longmean1,'\n']);  
    else
% do nothing
    end
    if mass2
        fprintf(fid, [mass2,'   ',sma2,'   ',ecc2,'   ',incl2,'   ',asc2,'   ',peri2,'   ',longmean2,'\n']);  
    else
% do nothing
    end
    if mass3
        fprintf(fid, [mass3,'   ',sma3,'   ',ecc3,'   ',incl3,'   ',asc3,'   ',peri3,'   ',longmean3,'\n']);  
    else
% do nothing
    end
    if mass4
        fprintf(fid, [mass4,'   ',sma4,'   ',ecc4,'   ',incl4,'   ',asc4,'   ',peri4,'   ',longmean4,'\n']);  
    else
% do nothing
    end
    if mass5
        fprintf(fid, [mass5,'   ',sma5,'   ',ecc5,'   ',incl5,'   ',asc5,'   ',peri5,'   ',longmean5,'\n']);  
    else
% do nothing
    end
    if mass6
        fprintf(fid, [mass6,'   ',sma6,'   ',ecc6,'   ',incl6,'   ',asc6,'   ',peri6,'   ',longmean6,'\n']);  
    else
% do nothing
    end
    if mass7
        fprintf(fid, [mass7,'   ',sma7,'   ',ecc7,'   ',incl7,'   ',asc7,'   ',peri7,'   ',longmean7,'\n']);  
    else
% do nothing
    end
    if mass8
        fprintf(fid, [mass8,'   ',sma8,'   ',ecc8,'   ',incl8,'   ',asc8,'   ',peri8,'   ',longmean8,'\n']);  
    else
% do nothing
    end
    if mass9
        fprintf(fid, [mass9,'   ',sma9,'   ',ecc9,'   ',incl9,'   ',asc9,'   ',peri9,'   ',longmean9,'\n']);  
    else
% do nothing
    end
    if mass10
        fprintf(fid, [mass10,'   ',sma10,'   ',ecc10,'   ',incl10,'   ',asc10,'   ',peri10,'   ',longmean10,'\n']);  
    else
% do nothing
    end
    fclose(fid);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%tic
    if strcmp(get(handles.verbose, 'Checked'),'on')
        cmd_string = ['!',LaplaceDir,'/hnbody init.hnb'];
    else
        cmd_string = ['!',LaplaceDir,'/hnbody -q init.hnb'];
    end
    eval(cmd_string)
%toc    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
movefile('0.dat','Sun.dat')
    for k = 1:N
        k_str = num2str(k);
        movefile([k_str,'.dat'],[planet{k},'.dat'])
    end
else
    jumprow = 4;
    fid = fopen( 'param.in', 'wt');
    fprintf(fid, ')O+_06 Integration parameters  (WARNING: Do not delete this line!!)\n');
    fprintf(fid, ['algorithm = ',Method,'\n']);
    fprintf(fid, ['start time = 0\n']);
    fprintf(fid, ['stop time = ',num2str(365.25*str2num(totint)),'\n']);
    fprintf(fid, ['output interval = ',num2str(365.25*str2num(outstep)),'\n']);                                                       
    fprintf(fid, ['timestep = ',num2str(365.25*str2num(integstep)),'\n']);
    fprintf(fid, ['accuracy parameter=1.d-12\n']);
    fprintf(fid, ['stop integration after a close encounter = no\n']);
    fprintf(fid, ['allow collisions to occur = no\n']);
    fprintf(fid, ['include collisional fragmentation = no\n']);
    fprintf(fid, ['express time in days or years = years\n']);
    fprintf(fid, ['express time relative to integration start time = yes\n']);
    fprintf(fid, ['output precision = medium\n']);
    fprintf(fid, ['< not used at present >\n']);
    fprintf(fid, ['include relativity in integration= no\n']);
    fprintf(fid, ['include user-defined force = no\n']);
    fprintf(fid, ['ejection distance (AU)= 100\n']);
    fprintf(fid, ['radius of central body (AU) = 0.005\n']);
    fprintf(fid, ['central mass (solar) = 1.0\n']);
    fprintf(fid, ['central J2 = 0\n']);
    fprintf(fid, ['central J4 = 0\n']);
    fprintf(fid, ['central J6 = 0\n']);
    fprintf(fid, ['< not used at present >\n']);
    fprintf(fid, ['< not used at present >\n']);
    fprintf(fid, ['Hybrid integrator changeover (Hill radii) = 3.\n']);
    numts = num2str(ceil(str2num(get(handles.edit_totint,'String'))/...
          str2num(get(handles.edit_integstep,'String'))/1000));
    fprintf(fid, ['number of timesteps between data dumps = ' numts '\n']);
    fprintf(fid, ['number of timesteps between periodic effects = 100\n']);
    fclose(fid);
    
    fid = fopen( 'element.in', 'wt');
    fprintf(fid, ')O+_06 element  (WARNING: Do not delete this line!!)\n');
    fprintf(fid, 'number of input files = 1\n');
    fprintf(fid, 'xv.out\n');
    fprintf(fid, 'type of elements (central body, barycentric, Jacobi) = Cen\n');
    fprintf(fid, 'minimum interval between outputs (days) = 3.6525\n');
    fprintf(fid, 'express time in days or years = years\n');
    fprintf(fid, 'express time relative to integration start time = yes\n');
    fprintf(fid, 'a10.7 e10.8 i10.6 g10.6 n10.6 l12.8 m13e\n');
    for k = 1:N
        fprintf(fid, [char(planet(k)),'\n']);
    end
    fclose(fid);
    
    fid = fopen( 'big.in', 'wt');
    fprintf(fid, [')O+_06 Big-body initial data  (WARNING: Do not delete this line!!)\n']);
    fprintf(fid, ['style = Asteroidal\n']);
    fprintf(fid, ['epoch (in days) = 0.\n']);
    if mass1
        periarg1 = num2str(str2num(peri1) - str2num(asc1),14);
        meanan1 = num2str(str2num(longmean1) - str2num(peri1),14);
        fprintf(fid,['Mercury','   m=',mass1,'\n']); 
        fprintf(fid, [sma1,'   ',ecc1,'   ',incl1,'   ',periarg1,'   ',asc1,'   ',meanan1,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass2
        periarg2 = num2str(str2num(peri2) - str2num(asc2),14);
        meanan2 = num2str(str2num(longmean2) - str2num(peri2),14);
        fprintf(fid,['Venus','   m=',mass2,'\n']); 
        fprintf(fid, [sma2,'   ',ecc2,'   ',incl2,'   ',periarg2,'   ',asc2,'   ',meanan2,'  0.  0.  0.\n']);  
    else
% do nothing
    end    
    if mass3
        periarg3 = num2str(str2num(peri3) - str2num(asc3),14);
        meanan3 = num2str(str2num(longmean3) - str2num(peri3),14);
        fprintf(fid,['Earth-Moon','   m=',mass3,'\n']); 
        fprintf(fid, [sma3,'   ',ecc3,'   ',incl3,'   ',periarg3,'   ',asc3,'   ',meanan3,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass4
        periarg4 = num2str(str2num(peri4) - str2num(asc4),14);
        meanan4 = num2str(str2num(longmean4) - str2num(peri4),14);
        fprintf(fid,['Mars','   m=',mass4,'\n']); 
        fprintf(fid, [sma4,'   ',ecc4,'   ',incl4,'   ',periarg4,'   ',asc4,'   ',meanan4,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass6
        periarg6 = num2str(str2num(peri6) - str2num(asc6),14);
        meanan6 = num2str(str2num(longmean6) - str2num(peri6),14);
        fprintf(fid,['Jupiter','   m=',mass6,'\n']); 
        fprintf(fid, [sma6,'   ',ecc6,'   ',incl6,'   ',periarg6,'   ',asc6,'   ',meanan6,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass7
        periarg7 = num2str(str2num(peri7) - str2num(asc7),14);
        meanan7 = num2str(str2num(longmean7) - str2num(peri7),14);
        fprintf(fid,['Saturn','   m=',mass7,'\n']); 
        fprintf(fid, [sma7,'   ',ecc7,'   ',incl7,'   ',periarg7,'   ',asc7,'   ',meanan7,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass8
        periarg8 = num2str(str2num(peri8) - str2num(asc8),14);
        meanan8 = num2str(str2num(longmean8) - str2num(peri8),14);
        fprintf(fid,['Uranus','   m=',mass8,'\n']); 
        fprintf(fid, [sma8,'   ',ecc8,'   ',incl8,'   ',periarg8,'   ',asc8,'   ',meanan8,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass9
        periarg9 = num2str(str2num(peri9) - str2num(asc9),14);
        meanan9 = num2str(str2num(longmean9) - str2num(peri9),14);
        fprintf(fid,['Neptune','   m=',mass9,'\n']); 
        fprintf(fid, [sma9,'   ',ecc9,'   ',incl9,'   ',periarg9,'   ',asc9,'   ',meanan9,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    if mass10
        periarg10 = num2str(str2num(peri10) - str2num(asc10),14);
        meanan10 = num2str(str2num(longmean10) - str2num(peri10),14);
        fprintf(fid,['Pluto','   m=',mass10,'\n']); 
        fprintf(fid, [sma10,'   ',ecc10,'   ',incl10,'   ',periarg10,'   ',asc10,'   ',meanan10,'  0.  0.  0.\n']);  
    else
% do nothing
    end  
    fclose(fid);
    
    fid = fopen( 'small.in', 'wt');
    fprintf(fid, [')O+_06 Small-body initial data  (WARNING: Do not delete this line!!)\n']);
    fprintf(fid, ['style = Asteroidal\n']);
    if mass5
        periarg5 = num2str(str2num(peri5) - str2num(asc5),14);
        meanan5 = num2str(str2num(longmean5) - str2num(peri5),14);
        fprintf(fid,['Asteroid','\n']); 
        fprintf(fid, [sma5,'   ',ecc5,'   ',incl5,'   ',periarg5,'   ',asc5,'   ',meanan5,'  0.  0.  0.\n']);  
    else
% do nothing
    end
    fclose(fid);
%tic    
    if strcmp(get(handles.verbose, 'Checked'),'on')
        cmd_string = ['!',LaplaceDir,'/mercury6_2 1'];
    else
        cmd_string = ['!',LaplaceDir,'/mercury6_2 2'];
    end
    eval(cmd_string)   
    cmd_string = ['!',LaplaceDir,'/element6'];
    eval(cmd_string)
%toc    
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    if exist('Earth-Mo.aei')
        movefile('Earth-Mo.aei','Earth-Moon.aei')
    end
    for k = 1:N
        movefile([char(planet(k)) '.aei'], [char(planet(k)) '.dat'])
    end

    delete *.dmp *.tmp *.out
end
set(handles.pushbutton_Integrate,'Enable','on')
set(handles.pushbutton_Plot,'Enable','on');
set(handles.pushbutton_Resonance,'Enable','on');
if item < 4
    set(handles.pushbutton_Lyapunov,'Enable','on');
else
    set(handles.pushbutton_Lyapunov,'Enable','off');
end
set(handles.popupmenu_element,'Enable','on');
set(handles.popupmenu_planet,'Enable','on');
set(handles.checkboxUser,'Enable','on','Value',0);
set(handles.pushbutton_FFT,'Enable','on');
set(handles.pushbutton_FMFT,'Enable','on');
set(handles.pushbutton_Wavelet,'Enable','on');
set(handles.pushbutton_PlotRes,'Enable','on');
set(handles.pushbutton_StartLFA,'Enable','on');

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%              3rd panel: Plot, Frequency analysis, and Lyapunov
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% --- Executes on selection change in popupmenu_element.
function popupmenu_element_Callback(hObject, eventdata, handles)
item = get(handles.popupmenu_element,'Value');
if item == 1;
    set(handles.edit_min_freq, 'String', '1e-3');
    set(handles.edit_max_freq, 'String', '5');
else
    set(handles.edit_min_freq, 'String', '1e-7');
    set(handles.edit_max_freq, 'String', '4e-5');
end
    

function checkboxUser_Callback(hObject, eventdata, handles)
if get(handles.checkboxUser,'Value')
    set(handles.popupmenu_element,'Enable','off');
    set(handles.popupmenu_planet,'Enable','off');    
    set(handles.pushbutton_FFT,'Enable','off');
    set(handles.pushbutton_FMFT,'Enable','off');
    set(handles.pushbutton_Wavelet,'Enable','off');
    set(handles.pushbutton_Resonance,'Enable','off');
    set(handles.pushbutton_Lyapunov,'Enable','off');
    set(handles.pushbutton_StartLFA,'Enable','off');    
else
    set(handles.popupmenu_element,'Enable','on');
    set(handles.popupmenu_planet,'Enable','on');
    set(handles.pushbutton_FFT,'Enable','on');
    set(handles.pushbutton_FMFT,'Enable','on');
    set(handles.pushbutton_Wavelet,'Enable','on');
    set(handles.pushbutton_Resonance,'Enable','on');
    set(handles.pushbutton_Lyapunov,'Enable','on');
    set(handles.pushbutton_StartLFA,'Enable','on');    
end

function pushbutton_ClearAppend_Callback(hObject, eventdata, handles)
clear global phi_tot xi1_tot
set(handles.pushbutton_ClearAppend,'Enable','off')

function pushbutton_Plot_Callback(hObject, eventdata, handles)
global jumprow
if get(handles.checkboxUser,'Value')
    currDir = cd;
    [filename, pathname] = uigetfile( ...
        {'*.m', 'All M-Files (*.m)'; ...
        '*.*','All Files (*.*)'}, ...
        'Choose function(s) to plot','UserFunctions/');
    if isequal([filename,pathname],[0,0])
        return
    else
        [pathstr, name, ext] = fileparts(filename);
        cd(pathname)
        eval(name)
        cd(currDir)
    end
else
    contents = get(handles.popupmenu_element,'String');
    item_element = get(handles.popupmenu_element,'Value');
    element = char(contents(item_element));
    contents = get(handles.popupmenu_planet,'String');
    item_planet = get(handles.popupmenu_planet,'Value');
    planet = char(contents(item_planet));
    file = [planet,'.dat'];
    if strcmp(planet,'Absent')
        warndlg('Planet absent. Please, change item.')
        return
    end
    [time semi ecc incl argperi longasc meananom] = ...
        textread(file,'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
%-------------- Rectify argperi -------------------------------------------  
    if strcmp(get(handles.Rectify,'Checked'),'on')
        x = argperi;
        Rectify
        argperi = x;
    end
%-------------- Rectify longasc -------------------------------------------  
    if strcmp(get(handles.Rectify,'Checked'),'on')
        x = longasc;
        Rectify
        longasc = x;
    end
%-------------- Rectify meananom ------------------------------------------- 
    if strcmp(get(handles.Rectify,'Checked'),'on')
        x = meananom;
        Rectify
        meananom = x;
    end 
%---------------------------------------------------------       
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    angle = [meananom meanlong argperi longperi longasc];
    if strcmp(get(handles.Rectify,'Checked'),'off')
        angle = angle - 360*floor(angle/360);
    end
    Elements = [semi  ecc  incl  angle  time];
    %----------------------------------------------------------------------
    clear time semi ecc incl longasc  argperi meananom longperi  meanlong
    if item_element == 1
        um = ' (AU)';
    elseif item_element == 2
        um = '';
    else
        um = ' (deg)';
    end
    figure
    plot(Elements(:,9),Elements(:,item_element),'r')
    title([planet,' - ',element,um],'FontSize',12)
    xlabel('time (yr)','FontSize',12)
    if (item_element == 1) | (item_element == 2)
        % do nothing
    else
        if strcmp(get(handles.no_degree, 'Checked'),'off')
            Degree_y
        end
    end
end

function pushbutton_Lyapunov_Callback(hObject, eventdata, handles)
global jumprow planet
contents = get(handles.popupmenu_planet,'String');
item_planet = get(handles.popupmenu_planet,'Value');
planet_plot = char(contents(item_planet));

if strcmp(planet_plot,'Absent')
    warndlg('Planet absent. Please, change item.')
    return
end
hh = msgbox(['Please wait, LAPLACE is computing the shadow orbit for ' planet_plot]);

if exist ('0.dat')
    delete 0.dat
end
if exist ('energy.dat')
    delete energy.dat
end
N = size(planet,1);
for k = 1:N
    movefile([char(planet(k)) '.dat'], [char(planet(k)) '.txt'])
end

str_p = num2str(item_planet);

d_o = 1e-12;
eval(['set(handles.edit_sma' str_p ',''String'',num2str(str2num(get(handles.edit_sma' str_p ',''String'')) + d_o,''%3.16g\n''))']);
%eval(['set(handles.edit_ecc' str_p ',''String'',num2str(str2num(get(handles.edit_ecc' str_p ',''String'')) + d_o,''%3.16g\n''))']);
%eval(['set(handles.edit_incl' str_p ',''String'',num2str(str2num(get(handles.edit_incl' str_p ',''String'')) + d_o,''%3.16g\n''))']);

pushbutton_Integrate_Callback(hObject, eventdata, handles)
close(hh);

eval(['set(handles.edit_sma' str_p ',''String'',num2str(str2num(get(handles.edit_sma' str_p ',''String'')) - d_o,''%3.10g\n''))']);
%eval(['set(handles.edit_ecc' str_p ',''String'',num2str(str2num(get(handles.edit_ecc' str_p ',''String'')) - d_o,''%3.10g\n''))']);
%eval(['set(handles.edit_incl' str_p ',''String'',num2str(str2num(get(handles.edit_incl' str_p ',''String'')) - d_o,''%3.10g\n''))']);

[time semi ecc incl argperi longasc meananom x1 x2 x3] = ...
    textread([planet_plot,'.txt'],'%f %f %f %f %f %f %f %*f %f %f %f','headerlines',jumprow);
longperi = longasc + argperi;
meanlong = meananom + longperi;
%{
chi_ecc = ecc.*cos(longperi);
eta_ecc = ecc.*sin(longperi);
chi_inc = incl.*cos(longasc);
eta_inc = incl.*sin(longasc);
%}
[time_p semi_p ecc_p incl_p argperi_p longasc_p meananom_p x1_p x2_p x3_p] = ...
    textread([planet_plot,'.dat'],'%f %f %f %f %f %f %f %*f %f %f %f','headerlines',jumprow);
longperi_p = longasc_p + argperi_p;
meanlong_p = meananom_p + longperi_p;
%{
chi_ecc_p = ecc_p.*cos(longperi_p);
eta_ecc_p = ecc_p.*sin(longperi_p);
chi_inc_p = incl_p.*cos(longasc_p);
eta_inc_p = incl_p.*sin(longasc_p);
%---------------------------------------------------------------------
dist_e_i = sqrt((chi_ecc_p - chi_ecc).^2 + (eta_ecc_p - eta_ecc).^2) ...
             + sqrt((chi_inc_p - chi_inc).^2 + (eta_inc_p - eta_inc).^2);

figure
plot(time,dist_e_i)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance (e,i)','FontSize',12)

figure
time(1) = eps;
plot(time,time./log(dist_e_i/dist_e_i(1)))
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Lyapunov time for e,i (yr)','FontSize',12)
%---------------------------------------------------------------------
%}
dist = sqrt((x1_p - x1).^2 + (x2_p - x2).^2 + (x3_p - x3).^2);

figure
plot(time,dist)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance (AU)','FontSize',12)

figure
time(1) = eps;
plot(time,time./log(dist/dist(1)))
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Lyapunov time (yr)','FontSize',12)
%--------------------------------------------------------------------
figure
plot(time,semi_p - semi)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance for sma (AU)','FontSize',12)

figure
plot(time,ecc_p - ecc)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance for ecc','FontSize',12)

figure
plot(time,incl_p - incl)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance for incl (deg)','FontSize',12)

figure
delta = meanlong - meanlong_p;
delta = delta - 360*floor(delta/360);
if  (delta(1) <= (360 + 1e-12)) & (delta(1) >= (360 - 1e-12))
    delta = delta - 360;
end
if  (delta(1) <= (-360 + 1e-12)) & (delta(1) >= (-360 - 1e-12))
    delta = delta + 360;
end
x = delta;
Rectify;
delta = x;
plot(time,delta)
title(planet_plot,'FontSize',12)
xlabel('time (yr)','FontSize',12)
ylabel('Shadow orbit distance for meanlong (deg)','FontSize',12)
%--------------------------------------------------------------------
delete *.dat

for k = 1:N
    movefile([char(planet(k)) '.txt'], [char(planet(k)) '.dat'])
end

function pushbutton_StartLFA_Callback(hObject, eventdata, handles)
if str2num(get(handles.edit_totint,'String'))/str2num(get(handles.edit_outstep,'String')) < 2^13
     warndlg('For a good precision, the Point number (i.e., Total integration time/Output step) must be at least equal to 2^13 = 8192',...
         'Increase the point number')
     return
end

set(handles.pushbutton_StartLFA,'Enable','off');
set(handles.pushbutton_StopLFA,'Enable','on');
set(handles.pushbutton_StartLFA,'Visible','off');
set(handles.pushbutton_StopLFA,'Visible','on');

planet = get(handles.popupmenu_planet,'String');
global LaplaceDir
cd(LaplaceDir)

N = 10;
for k = 1:10
    if strcmp(planet(k),'Absent')
        N = N-1;
    end
end

for k = 1:N
    while strcmp(planet(k),'Absent')
        planet(k) = '';   
    end
end

while size(planet,1) > N
    planet(N+1) = '';
end

item = get(handles.popupmenu_ODE,'Value');
if item == 1;
    Method = 'Symplectic';
elseif item == 2;
    Method = 'Bulirsch-Stoer';
elseif item == 3;
    Method = 'Runge-Kutta';
elseif item == 4;
    Method = 'MVS';
elseif item == 5;
    Method = 'Radau';
elseif item == 6;
    Method = 'BS2';
elseif item == 7;
    Method = 'Hybrid';
end

integstep = get(handles.edit_integstep,'String');
totint = get(handles.edit_totint,'String');
outstep = get(handles.edit_outstep,'String');

global ktime
ktime_str = num2str(ktime);
if strcmp(ktime_str,'')
    ktime = 0;
    ktime_str = num2str(ktime);
end

if item < 4
    jumprow = floor(str2num(totint)/str2num(outstep)) + 17;
    jpr = 17;
elseif item> 3
    jumprow = floor(str2num(totint)/str2num(outstep)) + 4;
    jpr = 4;
end

while strcmp(get(handles.pushbutton_StopLFA,'Visible'),'on')
    if item < 4
        fid = fopen( 'custom.hnb', 'wt');
        fprintf(fid, ['Integrator: ',Method,'\n']);
        fprintf(fid, ['StepSize: ',integstep,'\n']);
        fprintf(fid, ['Tfinal: ',totint,'\n']);
        fprintf(fid, ['OutputInterval: ',outstep,'\n']);
        fprintf(fid, ['EnergyInterval: ',outstep,'\n']);
        if get(handles.PostNewton, 'Value') == 1;
            fprintf(fid,'PostNewtonian = True\n');
        end
        for k = 1:N
            file = [char(planet(k)) '.dat'];
            [time semi ecc incl argperi longasc meananom mass] = ...
                textread(file,'%f %f %f %f %f %f %f %f %*f %*f %*f','headerlines',jumprow);
            longperi = longasc + argperi;
            meanlong = meananom + longperi;
            fseek(fid, 0, 'eof');
            fprintf(fid, [num2str(mass,20),' ', num2str(semi,20),' ',num2str(ecc,20),' ',num2str(incl,20),' ',num2str(longasc,20),' ',num2str(longperi,20),' ',num2str(meanlong,20) '\n']);  
        end
        fclose(fid);
        cmd_string = ['!',LaplaceDir,'/hnbody -q init.hnb'];
        eval(cmd_string)
        for k = 1:N
            k_str = num2str(k);
            delete([planet{k},'.dat'])
            movefile([k_str,'.dat'],[planet{k},'.dat'])
        end
    elseif item > 3
        fid = fopen( 'param.in', 'wt');
        fprintf(fid, ')O+_06 Integration parameters  (WARNING: Do not delete this line!!)\n');
        fprintf(fid, ['algorithm = ',Method,'\n']);
        fprintf(fid, ['start time = 0\n']);
        fprintf(fid, ['stop time = ',num2str(365.25*str2num(totint)),'\n']);
        fprintf(fid, ['output interval = ',num2str(365.25*str2num(outstep)),'\n']);                                                       
        fprintf(fid, ['timestep = ',num2str(365.25*str2num(integstep)),'\n']);
        fprintf(fid, ['accuracy parameter=1.d-12\n']);
        fprintf(fid, ['stop integration after a close encounter = no\n']);
        fprintf(fid, ['allow collisions to occur = no\n']);
        fprintf(fid, ['include collisional fragmentation = no\n']);
        fprintf(fid, ['express time in days or years = years\n']);
        fprintf(fid, ['express time relative to integration start time = yes\n']);
        fprintf(fid, ['output precision = medium\n']);
        fprintf(fid, ['< not used at present >\n']);
        fprintf(fid, ['include relativity in integration= no\n']);
        fprintf(fid, ['include user-defined force = no\n']);
        fprintf(fid, ['ejection distance (AU)= 100\n']);
        fprintf(fid, ['radius of central body (AU) = 0.005\n']);
        fprintf(fid, ['central mass (solar) = 1.0\n']);
        fprintf(fid, ['central J2 = 0\n']);
        fprintf(fid, ['central J4 = 0\n']);
        fprintf(fid, ['central J6 = 0\n']);
        fprintf(fid, ['< not used at present >\n']);
        fprintf(fid, ['< not used at present >\n']);
        fprintf(fid, ['Hybrid integrator changeover (Hill radii) = 3.\n']);
        numts = num2str(ceil(str2num(get(handles.edit_totint,'String'))/...
            str2num(get(handles.edit_integstep,'String'))/1000));
        fprintf(fid, ['number of timesteps between data dumps = ' numts '\n']);
        fprintf(fid, ['number of timesteps between periodic effects = 100\n']);
        fclose(fid);
    
        fid = fopen( 'element.in', 'wt');
        fprintf(fid, ')O+_06 element  (WARNING: Do not delete this line!!)\n');
        fprintf(fid, 'number of input files = 1\n');
        fprintf(fid, 'xv.out\n');
        fprintf(fid, 'type of elements (central body, barycentric, Jacobi) = Cen\n');
        fprintf(fid, 'minimum interval between outputs (days) = 3.6525\n');
        fprintf(fid, 'express time in days or years = years\n');
        fprintf(fid, 'express time relative to integration start time = yes\n');
        fprintf(fid, 'a20.16 e20.16 i20.16 g20.16 n20.16 l20.16 m13e\n');
        for k = 1:N
            fprintf(fid, [char(planet(k)),'\n']);
        end
        fclose(fid);
    
        fid = fopen( 'big.in', 'wt');
        fprintf(fid, [')O+_06 Big-body initial data  (WARNING: Do not delete this line!!)\n']);
        fprintf(fid, ['style = Asteroidal\n']);
        fprintf(fid, ['epoch (in days) = 0.\n']);
        for k = 1:N
            file = [char(planet(k)) '.dat'];
            if ~strcmp(file,'Asteroid.dat')
                [time semi ecc incl argperi longasc meananom mass] = ...
                    textread(file,'%f %f %f %f %f %f %f %f %*f %*f %*f','headerlines',jumprow);
                fseek(fid, 0, 'eof');
                fprintf(fid,[char(planet(k)),'   m=',num2str(mass,20),'\n']);
                fprintf(fid, [num2str(semi,20),' ',num2str(ecc,20),' ',num2str(incl,20),' ',num2str(argperi,20),' ',num2str(longasc,20),' ',num2str(meananom,20),'  0.  0.  0. \n']);
            end
        end
        fclose(fid);
    
        fid = fopen( 'small.in', 'wt');
        fprintf(fid, [')O+_06 Small-body initial data  (WARNING: Do not delete this line!!)\n']);
        fprintf(fid, ['style = Asteroidal\n']);
        for k = 1:N
            file = [char(planet(k)) '.dat'];
            if strcmp(file,'Asteroid.dat')
                [time semi ecc incl argperi longasc meananom mass] = ...
                    textread(file,'%f %f %f %f %f %f %f %f %*f %*f %*f','headerlines',jumprow);
                fseek(fid, 0, 'eof');
                fprintf(fid,['Asteroid   m=',num2str(mass,20),'\n']);
                fprintf(fid, [num2str(semi,20),' ',num2str(ecc,20),' ',num2str(incl,20),' ',num2str(argperi,20),' ',num2str(longasc,20),' ',num2str(meananom,20),'  0.  0.  0. \n']);
            end
        end
        fclose(fid);
    
        cmd_string = ['!',LaplaceDir,'/mercury6_2 2'];
        eval(cmd_string)   
        cmd_string = ['!',LaplaceDir,'/element6'];
        eval(cmd_string)
        delete *.dat *.dmp *.tmp *.out
        
        if exist('Earth-Mo.aei')
            movefile('Earth-Mo.aei','Earth-Moon.aei')
        end
        for k = 1:N
            movefile([char(planet(k)) '.aei'], [char(planet(k)) '.dat'])
        end
    end

    min_f = num2str(1000*str2num(get(handles.edit_fromfreq,'String')),'%6.12f');
    max_f = num2str(1000*str2num(get(handles.edit_tofreq,'String')),'%6.12f');    
    flag_FMFT = num2str(get(handles.popupmenu_FMFT_flag,'Value'));    
    nfreq = '1';
    outstep = get(handles.edit_outstep,'String');
    data_sep = num2str(2*pi*100000*str2num(outstep));
    for k = 1:N
        [time semi ecc incl argperi longasc meananom] = ...
            textread([planet{k},'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jpr);
        longperi = longasc + argperi;
        meanlong = longperi + meananom;
        d = size(time,1);    
        ndata = num2str(2^(floor(log2(d))));
        global LaplaceDir PhSpGeoDir

        if strcmp(planet(k),'Mercury')
            sma = str2num(get(handles.edit_sma1,'String'));
        elseif strcmp(planet(k),'Venus')
            sma = str2num(get(handles.edit_sma2,'String'));
        elseif strcmp(planet(k),'Earth-Moon')
            sma = str2num(get(handles.edit_sma3,'String'));
        elseif strcmp(planet(k),'Mars')
            sma = str2num(get(handles.edit_sma4,'String'));
        elseif strcmp(planet(k),'Asteroid')
            sma = str2num(get(handles.edit_sma5,'String'));    
        elseif strcmp(planet(k),'Jupiter')
            sma = str2num(get(handles.edit_sma6,'String'));
        elseif strcmp(planet(k),'Saturn')
            sma = str2num(get(handles.edit_sma7,'String'));
        elseif strcmp(planet(k),'Uranus')
            sma = str2num(get(handles.edit_sma8,'String'));
        elseif strcmp(planet(k),'Neptune')
            sma = str2num(get(handles.edit_sma9,'String'));
        elseif strcmp(planet(k),'Pluto')
            sma = str2num(get(handles.edit_sma10,'String'));
        end
        period = sqrt(sma^3);
        tm = ktime*str2num(totint);
        if str2num(outstep) < 1/2*period
 %           warndlg(['Output step > ', num2str(1/2*period), '.  Fourier analysis for Semimajor axis not correct (Nyquist-Shannon theorem)'], 'Output step too large')
 %       else
            semi_x = semi.*cos(pi/180*meanlong);
            semi_y = semi.*sin(pi/180*meanlong);
            fid = fopen(['input_semi.txt'], 'wt');
            fprintf(fid, '%14.10f %14.10f %14.10f\n',...
                [time'; semi_x'; semi_y']);
            fclose(fid);

            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' <input_semi.txt >FMFT_of_semi.txt'];  
            eval(cmd_string)
            delete input_semi.txt

            Freq = textread('FMFT_of_semi.txt', '%f %*f %*f', 'headerlines', 4);
            Freq = Freq/1000;
            set(figure(k), 'Visible', 'off');
            hold on           
            plot(tm,Freq,'.k','MarkerSize',10);
            title(char(planet(k)))    
            xlabel('Time (yr)', 'FontSize',10)
            ylabel('Frequency  (revolution/yr)')
        end        
 %   end

        if str2num(totint) > 500000
%            warndlg('Integration time too short for a correct Fourier analysis of Eccentricity and Inclination', 'Integration time < 500,000')
%        else
            ecc_x = ecc.*cos(pi/180*longperi);
            ecc_y = ecc.*sin(pi/180*longperi);
            fid = fopen(['input_ecc.txt'], 'wt');
            fprintf(fid, '%14.10f %14.10f %14.10f\n',...
                [time'; ecc_x'; ecc_y']);
            fclose(fid);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
                data_sep,' ',ndata,' <input_ecc.txt >FMFT_of_ecc.txt'];  
            eval(cmd_string)
            delete input_ecc.txt
            Freq = textread('FMFT_of_ecc.txt', '%f %*f %*f', 'headerlines', 4);
            Freq = Freq/1000;
            set(figure(k), 'Visible', 'off');
            hold on            
            plot(tm,Freq,'.r','MarkerSize',10);
            title(char(planet(k)))    
            xlabel('Time (yr)', 'FontSize',10)
            ylabel('Frequency  (revolution/yr)')

            incl_x = sin(pi/180*incl).*cos(pi/180*longasc);
            incl_y = sin(pi/180*incl).*sin(pi/180*longasc);
            fid = fopen(['input_incl.txt'], 'wt');
            fprintf(fid, '%14.10f %14.10f %14.10f\n',...
                [time'; incl_x'; incl_y']);
            fclose(fid);
            cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
            data_sep,' ',ndata,' <input_incl.txt >FMFT_of_incl.txt'];  
            eval(cmd_string)
            delete input_incl.txt
            Freq = textread('FMFT_of_incl.txt', '%f %*f %*f', 'headerlines', 4);
            Freq = Freq/1000;
            set(figure(k), 'Visible', 'off');
            hold on
            plot(tm,Freq,'.b','MarkerSize',10);
        end
%{            
        if (str2num(outstep) > 1/2*period) & (str2num(totint) > 500000)
            legend('Frequency 2', 'Frequency 3')
        elseif (str2num(outstep) < 1/2*period) & (str2num(totint) < 500000)
            legend('Frequency 1')
        elseif (str2num(outstep) > 1/2*period) & (str2num(totint) < 500000)
             % do nothing           
        else
            legend('Frequency 1','Frequency 2', 'Frequency 3')
        end
 %}
    end
    display(['Integration time (yr) = ',num2str(tm)])
    ktime = ktime + 1;
    drawnow
end
for k = 1:N
    set(figure(k), 'Visible', 'on');
    
    annotation(figure(k),'textbox',...
        [0.7 0.85 0.16 0.07],...
        'Color',[0 0 0],...
        'String',{'Frequency 1'},...
        'EdgeColor',[0 0 0]);

    annotation(figure(k),'textbox',...
        [0.7 0.75 0.16 0.07],...
        'Color',[1 0 0],...
        'String',{'Frequency 2'},...
        'EdgeColor',[1 0 0]);
    
    annotation(figure(k),'textbox',...
        [0.7 0.65 0.16 0.07],...
        'Color',[0 0 1],...
        'String',{'Frequency 3'},...
        'EdgeColor',[0 0 1]);
    
end
set(handles.pushbutton_StartLFA,'Enable','on');

function pushbutton_StopLFA_Callback(hObject, eventdata, handles)
display('Stop')
set(handles.pushbutton_StopLFA,'Enable','off');
set(handles.pushbutton_StopLFA,'Visible','off');
set(handles.pushbutton_StartLFA,'Enable','off');
set(handles.pushbutton_StartLFA,'Visible','on');


function pushbutton_FFT_Callback(hObject, eventdata, handles)
global jumprow
contents = get(handles.popupmenu_planet,'String');
item_planet = get(handles.popupmenu_planet,'Value');
planet = char(contents(item_planet));
file = [planet,'.dat'];
if strcmp(planet,'Absent')
    warndlg('Planet absent. Please, change item.')
    return
end
[time semi ecc incl argperi longasc meananom] = ...
    textread(file,'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
longperi = longasc + argperi;
meanlong = longasc + argperi + meananom;
d = size(time,1);    
nump = 2^(floor(log2(d)));
OutStep = str2num(get(handles.edit_outstep, 'String'));
freq_max = 2*pi/OutStep;
freq = [0 :freq_max/nump: freq_max];
freq(nump) = [];    
freq = (freq - freq_max/2)/(2*pi);    
valCheck = get(handles.check_log,'Value');

if strcmp(planet,'Mercury')
    sma = str2num(get(handles.edit_sma1,'String'));
elseif strcmp(planet,'Venus')
    sma = str2num(get(handles.edit_sma2,'String'));
elseif strcmp(planet,'Earth-Moon')
    sma = str2num(get(handles.edit_sma3,'String'));
elseif strcmp(planet,'Mars')
    sma = str2num(get(handles.edit_sma4,'String'));
elseif strcmp(planet,'Asteroid')
    sma = str2num(get(handles.edit_sma5,'String'));    
elseif strcmp(planet,'Jupiter')
    sma = str2num(get(handles.edit_sma6,'String'));
elseif strcmp(planet,'Saturn')
    sma = str2num(get(handles.edit_sma7,'String'));
elseif strcmp(planet,'Uranus')
    sma = str2num(get(handles.edit_sma8,'String'));
elseif strcmp(planet,'Neptune')
    sma = str2num(get(handles.edit_sma9,'String'));
elseif strcmp(planet,'Pluto')
    sma = str2num(get(handles.edit_sma10,'String'));
end
period = sqrt(sma^3);

if OutStep > 1/2*period
    warndlg(['Output step > ', num2str(1/2*period), '.  FFT for Semimajor axis not correct (Nyquist-Shannon theorem)'], 'Output step too large')
end

F = fft(semi.*cos(pi/180*meanlong) + i*(semi.*sin(pi/180*meanlong)), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title(['FFT for Semimajor axis of ', planet])    
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)


F = fft(ecc.*cos(pi/180*longperi) + i*(ecc.*sin(pi/180*longperi)), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title(['FFT for Eccentricity of ', planet])
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)

F = fft(sin(pi/180*incl).*cos(pi/180*longasc) + i*(sin(pi/180*incl).*sin(pi/180*longasc)), nump);    
figure    
Farray = sqrt(real(F).^2 + imag(F).^2);
Farray1 = Farray(1:nump/2, 1);    
Farray2 = Farray(nump/2+1:nump, 1);    
Farray = [Farray2;  Farray1];
if valCheck == 0;    
    plot(freq, Farray/nump)    
else    
    semilogy(freq, Farray/nump)    
end    
title(['FFT for Inclination of ', planet])
xlabel('Frequency', 'FontSize',10), ylabel('Amplitude', 'FontSize',10)

function pushbutton_FMFT_Callback(hObject, eventdata, handles)

if str2num(get(handles.edit_totint,'String'))/str2num(get(handles.edit_outstep,'String')) < 2^13
     warndlg('For a good precision, the Point number (i.e., Total integration time/Output step) must be at least equal to 2^13 = 8192',...
         'Increase the point number')
     return
end


global jumprow
contents = get(handles.popupmenu_element,'String');
item_element = get(handles.popupmenu_element,'Value');
element = char(contents(item_element));
    
contents = get(handles.popupmenu_planet,'String');
item_planet = get(handles.popupmenu_planet,'Value');
planet = char(contents(item_planet));
file = [planet,'.dat'];
if strcmp(planet,'Absent')
    warndlg('Planet absent. Please, change item.')
    return
end

if isdeployed
    hhh = helpdlg(sprintf(['Please wait, LAPLACE is calculating. \n',...
        'When this box will automatically shut down,\n'...
        'in the LAPLACE folder you will find\n'...
        'a text file containing the frequencies on KAM tori,\n'...
        'along with a graphical representation.']),...
        'Frequency Analysis');
else
    hhh = helpdlg(sprintf(['Please wait, LAPLACE is calculating. \n',...
        'When this box will automatically shut down,\n'...
        'in the MATLAB editor you will find\n'...
        'a text file containing the frequencies on KAM tori,\n'...
        'along with a graphical representation.']),...
        'Frequency Analysis');
end
min_f = num2str(1000*str2num(get(handles.edit_fromfreq,'String')),'%6.12f');
max_f = num2str(1000*str2num(get(handles.edit_tofreq,'String')),'%6.12f');

flag_FMFT = num2str(get(handles.popupmenu_FMFT_flag,'Value'));    
nfreq = get(handles.edit_nfreq,'String');
outstep = get(handles.edit_outstep,'String');
data_sep = num2str(2*pi*100000*str2num(outstep),'%6.12f');
[time semi ecc incl argperi longasc meananom] = ...
    textread(file,'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
longperi = longasc + argperi;
meanlong = longasc + argperi + meananom;
d = size(time,1);    
ndata = num2str(2^(floor(log2(d))));
global LaplaceDir PhSpGeoDir

if strcmp(element,'Semimajor axis');
    if strcmp(planet,'Mercury')
        sma = str2num(get(handles.edit_sma1,'String'));
    elseif strcmp(planet,'Venus')
        sma = str2num(get(handles.edit_sma2,'String'));
    elseif strcmp(planet,'Earth-Moon')
        sma = str2num(get(handles.edit_sma3,'String'));
    elseif strcmp(planet,'Mars')
        sma = str2num(get(handles.edit_sma4,'String'));
    elseif strcmp(planet,'Asteroid')
        sma = str2num(get(handles.edit_sma5,'String'));    
    elseif strcmp(planet,'Jupiter')
        sma = str2num(get(handles.edit_sma6,'String'));
    elseif strcmp(planet,'Saturn')
        sma = str2num(get(handles.edit_sma7,'String'));
    elseif strcmp(planet,'Uranus')
        sma = str2num(get(handles.edit_sma8,'String'));
    elseif strcmp(planet,'Neptune')
        sma = str2num(get(handles.edit_sma9,'String'));
    elseif strcmp(planet,'Pluto')
        sma = str2num(get(handles.edit_sma10,'String'));
    elseif strcmp(planet,'Sun')
        sma = str2num(get(handles.edit_sma1,'String'));        
    end
    period = sqrt(sma^3);
    
    if str2num(outstep) > 1/2*period
        warndlg(['Output step > ', num2str(1/2*period), '.  FMFT for Semimajor axis not correct (Nyquist-Shannon theorem)'], 'Output step too large')
    end
    semi_x = semi.*cos(pi/180*meanlong);
    semi_y = semi.*sin(pi/180*meanlong);
    fid = fopen(['input_semi.txt'], 'wt');
    fprintf(fid, '%14.10f %14.10f %14.10f\n',...
        [time'; semi_x'; semi_y']);
    fclose(fid);
    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
        data_sep,' ',ndata,' <input_semi.txt >FMFT_of_semi.txt'];  
    eval(cmd_string)
    delete input_semi.txt
        
    [Freq  Amp Phase] = textread('FMFT_of_semi.txt', '%f %f %f', 'headerlines', 4);
    Freq = Freq/1000;
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)
    title(['FMFT for Semimajor axis of ', planet])    
    xlabel('Frequency (rev/yr)', 'FontSize',10)
    
    fid = fopen(['FMFT_of_semi.txt'], 'a');
    fprintf(fid,'   \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for the semimajor axis of ',planet,'\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);           
    
    if isdeployed
        % do nothing
    else
        edit FMFT_of_semi.txt
    end
elseif strcmp(element,'Eccentricity');
    ecc_x = ecc.*cos(pi/180*longperi);
    ecc_y = ecc.*sin(pi/180*longperi);
    fid = fopen(['input_ecc.txt'], 'wt');
    fprintf(fid, '%14.10f %14.10f %14.10f\n',...
        [time'; ecc_x'; ecc_y']);
    fclose(fid);
    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
        data_sep,' ',ndata,' <input_ecc.txt >FMFT_of_ecc.txt'];  
    eval(cmd_string)
    delete input_ecc.txt
    
    [Freq  Amp Phase] = textread('FMFT_of_ecc.txt', '%f %f %f', 'headerlines', 4);
    Freq = Freq/1000;
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)    
    title(['FMFT for Eccentricity of ', planet])    
    xlabel('Frequency (revolution/yr)', 'FontSize',10)
        
    fid = fopen(['FMFT_of_ecc.txt'], 'a');
    fprintf(fid,'   \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for the eccentricity of ',planet,'\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);
    
    if isdeployed
        %do nothing
    else
        edit  FMFT_of_ecc.txt
    end
elseif strcmp(element,'Inclination');
    incl_x = sin(pi/180*incl).*cos(pi/180*longasc);
    incl_y = sin(pi/180*incl).*sin(pi/180*longasc);
    fid = fopen(['input_incl.txt'], 'wt');
    fprintf(fid, '%14.10f %14.10f %14.10f\n',...
        [time'; incl_x'; incl_y']);
    fclose(fid);
     
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
        data_sep,' ',ndata,' <input_incl.txt >FMFT_of_incl.txt'];  
    eval(cmd_string)
    delete input_incl.txt

    [Freq  Amp Phase] = textread('FMFT_of_incl.txt', '%f %f %f', 'headerlines', 4);
    Freq = Freq/1000;
    figure
    bar(Freq,(log10(Amp) + ceil(abs(min(log10(Amp))))),0.2)     
    title(['FMFT for Inclination of ', planet])    
    xlabel('Frequency (revolution/yr)', 'FontSize',10)
        
    fid = fopen(['FMFT_of_incl.txt'], 'a');
    fprintf(fid,'   \n');
    fprintf(fid,'**************************************************************\n');
    fprintf(fid, ['Frequency analysis for the inclination of ',planet,'\n']);
    fprintf(fid,'**************************************************************\n');
    fclose(fid);

    if isdeployed
        %do nothing
    else
        edit  FMFT_of_incl.txt
    end
else
    warndlg(sprintf(['For the frequency analysis you must select one of the following \n',...
        '1) ''Semimajor axis'' for Frequency 1 \n'...
        '2) ''Eccentricity'' for Frequency 2 \n'...
        '3) ''Inclination'' for Frequency 3']),...
        'Frequency Analysis');
end

close(hhh)

function pushbutton_Wavelet_Callback(hObject, eventdata, handles)

global LaplaceDir PhSpGeoDir min_freq max_freq eta sigma2 fourier_factor
global jumprow
contents = get(handles.popupmenu_element,'String');
item_element = get(handles.popupmenu_element,'Value');
element = char(contents(item_element));
    
contents = get(handles.popupmenu_planet,'String');
item_planet = get(handles.popupmenu_planet,'Value');
planet = char(contents(item_planet));
file = [planet,'.dat'];
if strcmp(planet,'Absent')
    warndlg('Planet absent. Please, change item.')
    return
end
h = helpdlg(sprintf(['Please wait, LAPLACE is calculating.']),...
    'Wavelet transform');
min_freq = str2num(get(handles.edit_min_freq,'String'));
max_freq = str2num(get(handles.edit_max_freq,'String'));
eta = 1;
sigma2 = (2*pi*str2num(get(handles.edit_Variance,'String')))^2;
fourier_factor = 2/(eta + sqrt(2/sigma2 + eta^2));
OutStep = str2num(get(handles.edit_outstep, 'String'));
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[time semi ecc incl argperi longasc meananom] = ...
    textread(file,'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
longperi = longasc + argperi;
meanlong = longasc + argperi + meananom;

if strcmp(element,'Semimajor axis');
    if strcmp(planet,'Mercury')
        sma = str2num(get(handles.edit_sma1,'String'));
    elseif strcmp(planet,'Venus')
        sma = str2num(get(handles.edit_sma2,'String'));
    elseif strcmp(planet,'Earth-Moon')
        sma = str2num(get(handles.edit_sma3,'String'));
    elseif strcmp(planet,'Mars')
        sma = str2num(get(handles.edit_sma4,'String'));
    elseif strcmp(planet,'Asteroid')
        sma = str2num(get(handles.edit_sma5,'String'));    
    elseif strcmp(planet,'Jupiter')
        sma = str2num(get(handles.edit_sma6,'String'));
    elseif strcmp(planet,'Saturn')
        sma = str2num(get(handles.edit_sma7,'String'));
    elseif strcmp(planet,'Uranus')
        sma = str2num(get(handles.edit_sma8,'String'));
    elseif strcmp(planet,'Neptune')
        sma = str2num(get(handles.edit_sma9,'String'));
    elseif strcmp(planet,'Pluto')
        sma = str2num(get(handles.edit_sma10,'String'));
    end
    period = sqrt(sma^3);
    if OutStep > 1/2*period
        close(h)
        warndlg(['Output step too large ( > ', num2str(1/2*period), ...
            ' ). Wavelet analysis for the semimajor axis of ',planet,' not computed.']);
        return
    else
        semi_x = semi.*cos(pi/180*meanlong);
        semi_y = semi.*sin(pi/180*meanlong);
        signal = semi_x + i*semi_y;         
    end

elseif strcmp(element,'Eccentricity');
    ecc_x = ecc.*cos(pi/180*longperi);
    ecc_y = ecc.*sin(pi/180*longperi);
    signal = ecc_x + i*ecc_y;
elseif strcmp(element,'Inclination');
    incl_x = sin(pi/180*incl).*cos(pi/180*longasc);
    incl_y = sin(pi/180*incl).*sin(pi/180*longasc);
    signal = incl_x + i*incl_y;
else
    close(h)
    warndlg(sprintf(['For the wavelet analysis you must select one of the following \n',...
        '1) ''Semimajor axis'' for Frequency 1 \n'...
        '2) ''Eccentricity'' for Frequency 2 \n'...
        '3) ''Inclination'' for Frequency 3']),...
        'Wavelet Analysis');
    return
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
[wt, Frequency] = wavelet_transf(signal, OutStep);
spectrum = (abs(wt)).^2;

if spectrum < 1000*eps
    warndlg('Frequency out of range')
    close(h)
    return
end

figure
colormap(gray)
contour(time, Frequency, spectrum)
xlabel('time (yr)', 'FontSize',12), ylabel('Frequency \times 1000', 'FontSize',12),
title(['Frequency for the ',element,' of ',planet], 'FontSize',12)

close(h)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            4rth panel: Frequency Modulation Indicator
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pushbutton_Calculate_Callback(hObject, eventdata, handles)
delete *.dat *.dmp *.tmp *.out *.aei

contents = get(handles.popupmenu_planetFMI_int,'String');
item_int = get(handles.popupmenu_planetFMI_int,'Value');
planetFMI_int = [char(contents(item_int)),'.dat'];
if strcmp(planetFMI_int,'Absent.dat')
    warndlg('Planet absent. Please, change item.')
    return
end

contents = get(handles.popupmenu_planetFMI_ext,'String');
item_ext = get(handles.popupmenu_planetFMI_ext,'Value');
planetFMI_ext = [char(contents(item_ext)),'.dat'];
if strcmp(planetFMI_ext,'Absent.dat')
    warndlg('Planet absent. Please, change item.')
    return
end

planet = char(contents(item_int));
if strcmp(planet,'Mercury')
    sma = str2num(get(handles.edit_sma1,'String'));
elseif strcmp(planet,'Venus')
    sma = str2num(get(handles.edit_sma2,'String'));
elseif strcmp(planet,'Earth-Moon')
    sma = str2num(get(handles.edit_sma3,'String'));
elseif strcmp(planet,'Mars')
    sma = str2num(get(handles.edit_sma4,'String'));
elseif strcmp(planet,'Asteroid')
    sma = str2num(get(handles.edit_sma5,'String'));    
elseif strcmp(planet,'Jupiter')
    sma = str2num(get(handles.edit_sma6,'String'));
elseif strcmp(planet,'Saturn')
    sma = str2num(get(handles.edit_sma7,'String'));
elseif strcmp(planet,'Uranus')
    sma = str2num(get(handles.edit_sma8,'String'));
elseif strcmp(planet,'Neptune')
    sma = str2num(get(handles.edit_sma9,'String'));
elseif strcmp(planet,'Pluto')
    sma = str2num(get(handles.edit_sma10,'String'));
end
global period_int
period_int = sqrt(sma^3);

planet = char(contents(item_ext));
if strcmp(planet,'Mercury')
    sma = str2num(get(handles.edit_sma1,'String'));
elseif strcmp(planet,'Venus')
    sma = str2num(get(handles.edit_sma2,'String'));
elseif strcmp(planet,'Earth-Moon')
    sma = str2num(get(handles.edit_sma3,'String'));
elseif strcmp(planet,'Mars')
    sma = str2num(get(handles.edit_sma4,'String'));
elseif strcmp(planet,'Asteroid')
    sma = str2num(get(handles.edit_sma5,'String'));    
elseif strcmp(planet,'Jupiter')
    sma = str2num(get(handles.edit_sma6,'String'));
elseif strcmp(planet,'Saturn')
    sma = str2num(get(handles.edit_sma7,'String'));
elseif strcmp(planet,'Uranus')
    sma = str2num(get(handles.edit_sma8,'String'));
elseif strcmp(planet,'Neptune')
    sma = str2num(get(handles.edit_sma9,'String'));
elseif strcmp(planet,'Pluto')
    sma = str2num(get(handles.edit_sma10,'String'));
end
global period_ext
period_ext = sqrt(sma^3);

global freq_ext_1 freq_ext_2 freq_ext_3 freq_int_1 freq_int_2 freq_int_3 FMI1 FMI2 FMI3
delete *.dat
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
contents = get(handles.popupmenu_ODE,'String');
item = get(handles.popupmenu_ODE,'Value');
Method = char(contents(item));
display('                                                                 ')
display('###################################################################')
display(['    STARTING COMPUTATION with ' Method ' !!!'])
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
%LaplaceDir = cd;
global LaplaceDir
if ~isnan(findstr(LaplaceDir, 'Slave'))
    % do nothing
else
    Totalbar = waitbar(0,'Please wait..., LAPLACE is calculating.',...
        'Units', 'pixel', 'Position', [392 470 380 70]);
end

%---------------------- Start multicore -----------------------------------
extfrom = str2num(get(handles.edit_extfrom,'String'));
extto = str2num(get(handles.edit_extto,'String'));
extstep = str2num(get(handles.edit_extstep,'String'));
extdelta = (extto - extfrom)/extstep;
ext_tot = extstep + 1;
parameterCell = cell(1,ext_tot);
subcell = cell(1,4);
ext_count = 1;
handles = rmfield(handles,'figure1');
handles = rmfield(handles,'output');
for ext = extfrom : extdelta : extto
    subcell{1,1} = [ext];
    subcell{1,2} = [handles];
    subcell{1,3} = [Totalbar];
    subcell{1,4} = [begin];
    parameterCell{1,ext_count} = {subcell};
    ext_count = ext_count + 1;
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(LaplaceDir)

%settings = struct('useWaitbar','true');
warning('off')
%resultCell = startmulticoremaster(@paralfor, parameterCell, settings);
resultCell = startmulticoremaster(@paralfor, parameterCell);
warning('on')
%---------------------- End multicore -----------------------------------
freq_ext_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    freq_ext_1 = [freq_ext_1; resultCell{1,k}(1,:)];
end
freq_ext_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    freq_ext_2 = [freq_ext_2; resultCell{1,k}(2,:)];
end
freq_ext_3 = [resultCell{1,1}(3,:)];
for k = 2 : ext_tot
    freq_ext_3 = [freq_ext_3; resultCell{1,k}(3,:)];
end
freq_int_1 = [resultCell{1,1}(4,:)];
for k = 2 : ext_tot
    freq_int_1 = [freq_int_1; resultCell{1,k}(4,:)];
end
freq_int_2 = [resultCell{1,1}(5,:)];
for k = 2 : ext_tot
    freq_int_2 = [freq_int_2; resultCell{1,k}(5,:)];
end
freq_int_3 = [resultCell{1,1}(6,:)];
for k = 2 : ext_tot
    freq_int_3 = [freq_int_3; resultCell{1,k}(6,:)];
end
FMI1 = [resultCell{1,1}(7,:)];
for k = 2 : ext_tot
    FMI1 = [FMI1; resultCell{1,k}(7,:)];
end
FMI2 = [resultCell{1,1}(8,:)];
for k = 2 : ext_tot
    FMI2 = [FMI2; resultCell{1,k}(8,:)];
end
FMI3 = [resultCell{1,1}(9,:)];
for k = 2 : ext_tot
    FMI3 = [FMI3; resultCell{1,k}(9,:)];
end

freq_ext_1 = freq_ext_1/1000;
freq_ext_2 = freq_ext_2/1000*360*60*60;
freq_ext_3 = freq_ext_3/1000*360*60*60;
freq_int_1 = freq_int_1/1000;
freq_int_2 = freq_int_2/1000*360*60*60;
freq_int_3 = freq_int_3/1000*360*60*60;

%-------------------- Save to save_now ------------------------------------
freq_ext_1 = freq_ext_1';
freq_ext_2 = freq_ext_2';
freq_ext_3 = freq_ext_3';
freq_int_1 = freq_int_1';
freq_int_2 = freq_int_2';
freq_int_3 = freq_int_3';
FMI1 = FMI1';
FMI2 = FMI2';
FMI3 = FMI3';
save freq1st1.dat freq_ext_1 -ascii
save freq1st2.dat freq_ext_2 -ascii
save freq1st3.dat freq_ext_3 -ascii
save freq2nd1.dat freq_int_1 -ascii
save freq2nd2.dat freq_int_2 -ascii
save freq2nd3.dat freq_int_3 -ascii
save FMI1.dat FMI1 -ascii
save FMI2.dat FMI2 -ascii
save FMI3.dat FMI3 -ascii
freq_ext_1 = freq_ext_1';
freq_ext_2 = freq_ext_2';
freq_ext_3 = freq_ext_3';
freq_int_1 = freq_int_1';
freq_int_2 = freq_int_2';
freq_int_3 = freq_int_3';
FMI1 = FMI1';
FMI2 = FMI2';
FMI3 = FMI3';
delete *.txt
%--------------------------------------------------------------------------
if get(handles.check1st1,'Value')|get(handles.check1st2,'Value')|get(handles.check1st3,'Value')...
        |get(handles.check2nd1,'Value')|get(handles.check2nd2,'Value')|get(handles.check2nd3,'Value')
    set(handles.pushbutton_Frequencies, 'Enable', 'on')
    intstep = str2num(get(handles.edit_intstep,'String'));
    if intstep ~= 0
        set(handles.pushbutton_LevelLines, 'Enable', 'on')
    end
end

if strcmp(get(handles.edit_stepFMI1,'String'),'0') & strcmp(get(handles.edit_stepFMI2,'String'),'0') & strcmp(get(handles.edit_stepFMI3,'String'),'0')
    % do nothing
else
    set(handles.pushbuttonFMI, 'Enable', 'on')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('-------------------------------------------------------------------')
display('                       FINISH !!!')
seconds = toc;
minutes = 0;
hours = 0;
days = 0;
if seconds >= 60
    minutes = floor(seconds/60);
    seconds = seconds - 60*minutes;
    if minutes >= 60
        hours = floor(minutes/60);
        minutes = minutes - 60*hours;
        if hours >= 24;
            days = floor(hours/24);
            hours = hours - 24*days;
        end            
    end
end
disp(['Elapsed time: ' num2str(days) ' days, ' num2str(hours) ' hours, '  num2str(minutes) ' minutes, ' num2str(seconds) ' seconds.'])
display('###################################################################')
if exist('Totalbar')
    close(Totalbar)
end
set(handles.count,'String','0');
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popupmenu_planetFMI_ext_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function popupmenu_planetFMI_int_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function popupmenu_action_ext_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function popupmenu_action_int_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_intfrom_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_intto_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_intstep_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) == 0
    set(handles.edit_intto,'Enable','off')
%    uibutton(handles.uipanel10,'Style','text','Interpreter','LaTex','String','$=$','FontSize',12,...
%    'BackgroundColor',[0.925  0.914  0.847],'Position',[256 33 20 20])
else
    set(handles.edit_intto,'Enable','on')
%    uibutton(handles.uipanel10,'Style','text','Interpreter','LaTex','String','$\leq$','FontSize',12,...
%    'BackgroundColor',[0.925  0.914  0.847],'Position',[256 33 20 20])
end
DisableAll
%--------------------------------------------------------------------------
function edit_extfrom_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_extto_Callback(hObject, eventdata, handles)
DisableAll
%--------------------------------------------------------------------------
function edit_extstep_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end
DisableAll
%--------------------------------------------------------------------------
function edit_minfreq1_Callback(hObject, eventdata, handles)
DisableAll
function edit_maxfreq1_Callback(hObject, eventdata, handles)
DisableAll
function edit_stepFMI1_Callback(hObject, eventdata, handles)
DisableAll
function edit_minfreq2_Callback(hObject, eventdata, handles)
DisableAll
function edit_maxfreq2_Callback(hObject, eventdata, handles)
DisableAll
function edit_stepFMI2_Callback(hObject, eventdata, handles)
DisableAll
function edit_minfreq3_Callback(hObject, eventdata, handles)
DisableAll
function edit_maxfreq3_Callback(hObject, eventdata, handles)
DisableAll
function edit_stepFMI3_Callback(hObject, eventdata, handles)
DisableAll
function check1st1_Callback(hObject, eventdata, handles)
DisableAll
function check1st2_Callback(hObject, eventdata, handles)
DisableAll
function check1st3_Callback(hObject, eventdata, handles)
DisableAll
function check2nd1_Callback(hObject, eventdata, handles)
DisableAll
function check2nd2_Callback(hObject, eventdata, handles)
DisableAll
function check2nd3_Callback(hObject, eventdata, handles)
DisableAll

%--------------------------------------------------------------------------
function pushbuttonFMI_Callback(hObject, eventdata, handles)
global FMI1 FMI2 FMI3
extfrom = str2num(get(handles.edit_extfrom,'String'));
extto = str2num(get(handles.edit_extto,'String'));
extstep = str2num(get(handles.edit_extstep,'String'));
extdelta = (extto - extfrom)/extstep;
intfrom = str2num(get(handles.edit_intfrom,'String'));
intto = str2num(get(handles.edit_intto,'String'));
intstep = str2num(get(handles.edit_intstep,'String'));
intdelta = (intto - intfrom)/intstep;
ext = extfrom : extdelta : extto;
int = intfrom : intdelta : intto;
contents = get(handles.popupmenu_action_ext,'String');
item = get(handles.popupmenu_action_ext,'Value');
action_ext = char(contents(item));
contents = get(handles.popupmenu_action_int,'String');
item = get(handles.popupmenu_action_int,'Value');
action_int = char(contents(item));
contents = get(handles.popupmenu_planetFMI_int,'String');
item_int = get(handles.popupmenu_planetFMI_int,'Value');
planetFMI_int = char(contents(item_int));
contents = get(handles.popupmenu_planetFMI_ext,'String');
item_ext = get(handles.popupmenu_planetFMI_ext,'Value');
planetFMI_ext = char(contents(item_ext));

if intstep > 0
    if str2num(get(handles.edit_stepFMI1,'String')) > 0;
        figure
        colormap(gray)
        surf(ext, int, FMI1', 'FaceColor', 'interp', 'LineStyle', ':');
        view(2)
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title('FMI 1', 'FontSize',14)
    end

    if str2num(get(handles.edit_stepFMI2,'String')) > 0;
        figure
        colormap(gray)
        surf(ext, int, FMI2', 'FaceColor', 'interp', 'LineStyle', ':');
        view(2)
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title('FMI 2', 'FontSize',14)
    end

    if str2num(get(handles.edit_stepFMI3,'String')) > 0;
        figure
        colormap(gray)
        surf(ext, int, FMI3', 'FaceColor', 'interp', 'LineStyle', ':');
        view(2)
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title('FMI 3', 'FontSize',14)
    end
elseif intstep == 0
    if str2num(get(handles.edit_stepFMI1,'String')) > 0;
        figure
        plot(ext, FMI1(:,:))
        title('FMI 1', 'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end

    if str2num(get(handles.edit_stepFMI2,'String')) > 0;
        figure
        plot(ext, FMI2(:,:))
        title('FMI 2', 'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end

    if str2num(get(handles.edit_stepFMI3,'String')) > 0;
        figure
        plot(ext, FMI3(:,:))
        title('FMI 3', 'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end
end 
%--------------------------------------------------------------------------
function pushbutton_Frequencies_Callback(hObject, eventdata, handles)
global freq_ext_1 freq_ext_2 freq_ext_3 freq_int_1 freq_int_2 freq_int_3 period_ext period_int
extfrom = str2num(get(handles.edit_extfrom,'String'));
extto = str2num(get(handles.edit_extto,'String'));
extstep = str2num(get(handles.edit_extstep,'String'));
extdelta = (extto - extfrom)/extstep;
intfrom = str2num(get(handles.edit_intfrom,'String'));
intto = str2num(get(handles.edit_intto,'String'));
intstep = str2num(get(handles.edit_intstep,'String'));
intdelta = (intto - intfrom)/intstep;
ext = extfrom : extdelta : extto;
int = intfrom : intdelta : intto;
contents = get(handles.popupmenu_action_ext,'String');
item = get(handles.popupmenu_action_ext,'Value');
action_ext = char(contents(item));
contents = get(handles.popupmenu_action_int,'String');
item = get(handles.popupmenu_action_int,'Value');
action_int = char(contents(item));
contents = get(handles.popupmenu_planetFMI_int,'String');
item_int = get(handles.popupmenu_planetFMI_int,'Value');
planetFMI_int = char(contents(item_int));
contents = get(handles.popupmenu_planetFMI_ext,'String');
item_ext = get(handles.popupmenu_planetFMI_ext,'Value');
planetFMI_ext = char(contents(item_ext));

if intstep > 0
    if get(handles.check1st1,'Value')
        if str2num(get(handles.edit_outstep,'String')) < 1/2*period_ext;
            figure
            colormap(gray)          
            surfc(ext, int, freq_ext_1', 'FaceColor', 'interp', 'LineStyle', ':');
            xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
            title(['Freq 1 (rev/yr) of ',planetFMI_ext], 'FontSize',14)
        else
            warndlg(['Output step > ', num2str(1/2*period_ext), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');
        end
    end

    if get(handles.check1st2,'Value')
        figure
        colormap(gray)        
        surfc(ext, int, freq_ext_2', 'FaceColor', 'interp', 'LineStyle', ':');
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 2 (arcsec/yr) of ',planetFMI_ext], 'FontSize',14)
    end

    if get(handles.check1st3,'Value')
        figure
        colormap(gray)       
        surfc(ext, int, freq_ext_3', 'FaceColor', 'interp', 'LineStyle', ':');
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 3 (arcsec/yr) of ',planetFMI_ext], 'FontSize',14)
    end
    
    if get(handles.check2nd1,'Value')
        if str2num(get(handles.edit_outstep,'String')) < 1/2*period_int;
            figure
            colormap(gray)
            surfc(ext, int, freq_int_1', 'FaceColor', 'interp', 'LineStyle', ':');
            xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
            title(['Freq 1 (rev/yr) of ',planetFMI_int], 'FontSize',14)
        else
            warndlg(['Output step > ', num2str(1/2*period_int), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');
        end
    end

    if get(handles.check2nd2,'Value')
        figure
        colormap(gray)
        surfc(ext, int, freq_int_2', 'FaceColor', 'interp', 'LineStyle', ':');
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 2 (arcsec/yr) of ',planetFMI_int], 'FontSize',14)
    end

    if get(handles.check2nd3,'Value')
        figure
        colormap(gray)
        surfc(ext, int, freq_int_3', 'FaceColor', 'interp', 'LineStyle', ':');
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 3 (arcsec/yr) of ',planetFMI_int], 'FontSize',14)
    end
      
elseif intstep == 0 
    if get(handles.check1st1,'Value')   
        if str2num(get(handles.edit_outstep,'String')) < 1/2*period_ext;
            figure
            plot(ext, freq_ext_1(:,:))
        else
            warndlg(['Output step > ', num2str(1/2*period_ext), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');            
        end
        title(['Freq 1 (rev/yr) of ',planetFMI_ext],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end
    
    if get(handles.check1st2,'Value')
        figure
        plot(ext, freq_ext_2(:,:))      
        title(['Freq 2 (arcsec/yr) of ',planetFMI_ext],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end
    
    if get(handles.check1st3,'Value')
        figure
        plot(ext, freq_ext_3(:,:))      
        title(['Freq 3 (arcsec/yr) of ',planetFMI_ext],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end    
 
    if get(handles.check2nd1,'Value')
        if str2num(get(handles.edit_outstep,'String')) < 1/2*period_int;
            figure
            plot(ext, freq_int_1(:,:))
        else
            warndlg(['Output step > ', num2str(1/2*period_int), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');            
        end
        title(['Freq 1(rev/yr) of ',planetFMI_int],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end
    
    if get(handles.check2nd2,'Value')
        figure
        plot(ext, freq_int_2(:,:))      
        title(['Freq 2 (arcsec/yr) of ',planetFMI_int],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end
    
    if get(handles.check2nd3,'Value')
        figure
        plot(ext, freq_int_3(:,:))      
        title(['Freq 3 (arcsec/yr) of ',planetFMI_int],'FontSize',12)
        xlabel([action_ext,' - ',planetFMI_ext], 'FontSize',14)
    end        
end
%--------------------------------------------------------------------------
function pushbutton_LevelLines_Callback(hObject, eventdata, handles)
global freq_ext_1 freq_ext_2 freq_ext_3 freq_int_1 freq_int_2 freq_int_3 period_ext period_int
extfrom = str2num(get(handles.edit_extfrom,'String'));
extto = str2num(get(handles.edit_extto,'String'));
extstep = str2num(get(handles.edit_extstep,'String'));
extdelta = (extto - extfrom)/extstep;
intfrom = str2num(get(handles.edit_intfrom,'String'));
intto = str2num(get(handles.edit_intto,'String'));
intstep = str2num(get(handles.edit_intstep,'String'));
intdelta = (intto - intfrom)/intstep;
ext = extfrom : extdelta : extto;
int = intfrom : intdelta : intto;
contents = get(handles.popupmenu_action_ext,'String');
item = get(handles.popupmenu_action_ext,'Value');
action_ext = char(contents(item));
contents = get(handles.popupmenu_action_int,'String');
item = get(handles.popupmenu_action_int,'Value');
action_int = char(contents(item));
contents = get(handles.popupmenu_planetFMI_int,'String');
item_int = get(handles.popupmenu_planetFMI_int,'Value');
planetFMI_int = char(contents(item_int));
contents = get(handles.popupmenu_planetFMI_ext,'String');
item_ext = get(handles.popupmenu_planetFMI_ext,'Value');
planetFMI_ext = char(contents(item_ext));

if get(handles.check1st1,'Value')
    if str2num(get(handles.edit_outstep,'String')) < 1/2*period_ext;
        figure
        colormap(gray)
        [C,h] = contour(ext, int, freq_ext_1');
        clabel(C,h);
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 1 (rev/yr) of ',planetFMI_ext], 'FontSize',14)
    else
        warndlg(['Output step > ', num2str(1/2*period_ext), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');
    end
end

if get(handles.check1st2,'Value')
    figure
    colormap(gray)
    [C,h] = contour(ext, int, freq_ext_2');
    clabel(C,h);
    xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
    title(['Freq 2 (arcsec/yr) of ',planetFMI_ext], 'FontSize',14)
end

if get(handles.check1st3,'Value')
    figure
    colormap(gray)
    [C,h] = contour(ext, int, freq_ext_3');
    clabel(C,h);
    xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
    title(['Freq 3 (arcsec/yr) of ',planetFMI_ext], 'FontSize',14)
end

if get(handles.check2nd1,'Value')
    if str2num(get(handles.edit_outstep,'String')) < 1/2*period_int;
        figure
        colormap(gray)
        [C,h] = contour(ext, int, freq_int_1');
        clabel(C,h);
        xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
        title(['Freq 1 (rev/yr) of ',planetFMI_int], 'FontSize',14)
    else
        warndlg(['Output step > ', num2str(1/2*period_int), '.  The values relative to Frequency 1 will not be displayed (Nyquist-Shannon theorem)'], 'Output step too large');
    end
end

if get(handles.check2nd2,'Value')
    figure
    colormap(gray)
    [C,h] = contour(ext, int, freq_int_2');
    clabel(C,h);
    xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
    title(['Freq 2 (arcsec/yr) of ',planetFMI_int], 'FontSize',14)
end

if get(handles.check2nd3,'Value')
    figure
    colormap(gray)
    [C,h] = contour(ext, int, freq_int_3');
    clabel(C,h);
    xlabel([action_ext,' - ',planetFMI_ext],'FontSize',14), ylabel([action_int,' - ',planetFMI_int], 'FontSize',14)
    title(['Freq 3 (arcsec/yr) of ',planetFMI_int], 'FontSize',14)
end

%--------------------------------------------------------------------------
function pushbutton_StartSlave_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)
startmulticoreslave

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            5th panel: Check Resonances
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function pushbutton_Resonance_Callback(hObject, eventdata, handles)
set(handles.uipanel15,'Visible','off');
set(handles.uipanel20,'Visible','on');

function pushbutton_close_Callback(hObject, eventdata, handles)
set(handles.uipanel15,'Visible','on');
set(handles.uipanel20,'Visible','off');

function edit_k1_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k1,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k1,'String','1')
end
    
function edit_k2_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k2,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k2,'String','1')
end

function edit_k3_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k3,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k3,'String','1')
end

function edit_k4_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k4,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k4,'String','1')
end

function edit_k5_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k5,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k5,'String','1')
end

function edit_k6_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k6,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k6,'String','1')
end

function edit_k7_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k7,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k7,'String','1')
end

function edit_k8_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k8,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k8,'String','1')
end

function edit_k9_Callback(hObject, eventdata, handles)
val = str2num(get(handles.edit_k9,'String'));
if val ~= floor(val)
    warndlg('Entry must be an integer')
    set(handles.edit_k9,'String','1')
end


function popupmenu_R1_Callback(hObject, eventdata, handles)

function popupmenu_R2_Callback(hObject, eventdata, handles)

function popupmenu_R3_Callback(hObject, eventdata, handles)

function popupmenu_R4_Callback(hObject, eventdata, handles)

function popupmenu_R5_Callback(hObject, eventdata, handles)

function popupmenu_R6_Callback(hObject, eventdata, handles)

function popupmenu_R7_Callback(hObject, eventdata, handles)

function popupmenu_R8_Callback(hObject, eventdata, handles)

function popupmenu_R9_Callback(hObject, eventdata, handles)


function popupmenu_P1_Callback(hObject, eventdata, handles)

function popupmenu_P2_Callback(hObject, eventdata, handles)

function popupmenu_P3_Callback(hObject, eventdata, handles)

function popupmenu_P4_Callback(hObject, eventdata, handles)

function popupmenu_P5_Callback(hObject, eventdata, handles)

function popupmenu_P6_Callback(hObject, eventdata, handles)

function popupmenu_P7_Callback(hObject, eventdata, handles)

function popupmenu_P8_Callback(hObject, eventdata, handles)

function popupmenu_P9_Callback(hObject, eventdata, handles)


function pushbutton_PlotRes_Callback(hObject, eventdata, handles)
global jumprow
for rr = 1:9
    rr = num2str(rr);
    P_rr = ['k',rr,' = str2num(get(handles.edit_k', rr, ',''String''));'];
    eval(P_rr)
end

contents = get(handles.popupmenu_R1,'String');
item_element = get(handles.popupmenu_R1,'Value');
element1 = char(contents(item_element));
contents = get(handles.popupmenu_P1,'String');
item_planet = get(handles.popupmenu_P1,'Value');
planet1 = char(contents(item_planet));

if k1 & ~strcmp(planet1,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet1,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = k1*Elements(:,item_element);
else
    warndlg('You must select at least two planets on the right pop-up menu and two integers on the left column');
    return
end

contents = get(handles.popupmenu_R2,'String');
item_element = get(handles.popupmenu_R2,'Value');
element2 = char(contents(item_element));
contents = get(handles.popupmenu_P2,'String');
item_planet = get(handles.popupmenu_P2,'Value');
planet2 = char(contents(item_planet));

if k2 & ~strcmp(planet2,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet2,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k2*Elements(:,item_element);
else
    warndlg('You must select at least two planets on the right pop-up menu and two integers on the left column');
    return
end

contents = get(handles.popupmenu_R3,'String');
item_element = get(handles.popupmenu_R3,'Value');
element3 = char(contents(item_element));
contents = get(handles.popupmenu_P3,'String');
item_planet = get(handles.popupmenu_P3,'Value');
planet3 = char(contents(item_planet));

if k3 & ~strcmp(planet3,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet3,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k3*Elements(:,item_element);
end

contents = get(handles.popupmenu_R4,'String');
item_element = get(handles.popupmenu_R4,'Value');
element4 = char(contents(item_element));
contents = get(handles.popupmenu_P4,'String');
item_planet = get(handles.popupmenu_P4,'Value');
planet4 = char(contents(item_planet));

if k4 & ~strcmp(planet4,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet4,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k4*Elements(:,item_element);
end

contents = get(handles.popupmenu_R5,'String');
item_element = get(handles.popupmenu_R5,'Value');
element5 = char(contents(item_element));
contents = get(handles.popupmenu_P5,'String');
item_planet = get(handles.popupmenu_P5,'Value');
planet5 = char(contents(item_planet));

if k5 & ~strcmp(planet5,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet5,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k5*Elements(:,item_element);
end

contents = get(handles.popupmenu_R6,'String');
item_element = get(handles.popupmenu_R6,'Value');
element6 = char(contents(item_element));
contents = get(handles.popupmenu_P6,'String');
item_planet = get(handles.popupmenu_P6,'Value');
planet6 = char(contents(item_planet));

if k6 & ~strcmp(planet6,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet6,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k6*Elements(:,item_element);
end

contents = get(handles.popupmenu_R7,'String');
item_element = get(handles.popupmenu_R7,'Value');
element7 = char(contents(item_element));
contents = get(handles.popupmenu_P7,'String');
item_planet = get(handles.popupmenu_P7,'Value');
planet7 = char(contents(item_planet));

if k7 & ~strcmp(planet7,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet7,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k7*Elements(:,item_element);
end

contents = get(handles.popupmenu_R8,'String');
item_element = get(handles.popupmenu_R8,'Value');
element8 = char(contents(item_element));
contents = get(handles.popupmenu_P8,'String');
item_planet = get(handles.popupmenu_P8,'Value');
planet8 = char(contents(item_planet));

if k8 & ~strcmp(planet8,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet8,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k8*Elements(:,item_element);
end

contents = get(handles.popupmenu_R9,'String');
item_element = get(handles.popupmenu_R9,'Value');
element9 = char(contents(item_element));
contents = get(handles.popupmenu_P9,'String');
item_planet = get(handles.popupmenu_P9,'Value');
planet9 = char(contents(item_planet));

if k9 & ~strcmp(planet9,'Absent')
    [time semi ecc incl argperi longasc meananom] = ...
        textread([planet9,'.dat'],'%f %f %f %f %f %f %f %*f %*f %*f %*f','headerlines',jumprow);
    longperi = longasc + argperi;
    meanlong = longasc + argperi + meananom;
    Elements = [meanlong longperi longasc];
    Res_angle = Res_angle + k9*Elements(:,item_element);
end

Res_angle = Res_angle - 360*floor(Res_angle/360) - 180;
%-------------- Rectify angle -------------------------------------------
if strcmp(get(handles.Rectify,'Checked'),'on')
    x = Res_angle;
    Rectify
    Res_angle = x;
end
%---------------------------------------------------------
if Res_angle(1:10) == -180
    warndlg('Please, select at least two planets and two non null corresponding harmonics');
    return
end
figure
plot(time, Res_angle)
if strcmp(get(handles.no_degree, 'Checked'),'off')
    Degree_y
else
    ylabel('(deg)', 'FontSize',14)
end
xlabel('time (yr)', 'FontSize',14)
title('Resonant angle', 'FontSize',14);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                      Menu'
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' File
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function File_Callback(hObject, eventdata, handles)
%--------------------------------------------------------------------------
function Load_Callback(hObject, eventdata, handles)
global LaplaceDir PhSpGeoDir
[filename, pathname] = uigetfile( ...
    {'*.mat', 'All MAT-Files (*.mat)'; ...
    '*.*','All Files (*.*)'}, ...
    'Load Initial Data','Init/');
if isequal([filename,pathname],[0,0])
    return
else
    [pathstr, name, ext] = fileparts(filename);
    cd(pathname)
    load([name,'.mat'])
    cd(LaplaceDir)
end

SetInit
DisableAll
SetPlanet
if str2num(get(handles.edit_intstep,'String')) == 0
    set(handles.edit_intto,'Enable','off')
else
    set(handles.edit_intto,'Enable','on')
end
%--------------------------------------------------------------------------
function Save_Callback(hObject, eventdata, handles)
[filename, pathname] = uiputfile( ...
    {'*.mat', 'MAT-Files (*.mat)'; ...
    '*.*','All Files (*.*)'}, ...
    'Save Initial Data','Init/');
if isequal([filename,pathname],[0,0])
    return
else
    InitStructure
    save([pathname,filename], '-struct', 'InitStr')
end
%--------------------------------------------------------------------------
function closeall_Callback(hObject, eventdata, handles)
close all hidden
%--------------------------------------------------------------------------
function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end
%--------------------------------------------------------------------------
function Save_now_Callback(hObject, eventdata, handles)
global LaplaceDir PhSpGeoDir
InitStructure
cd(LaplaceDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(LaplaceDir)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' Window
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Window_Callback(hObject, eventdata, handles)

function CloseFig_Callback(hObject, eventdata, handles)
close all
% --------------------------------------------------------------------
function verbose_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

%x%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Menu' Figure
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Figure_Callback(hObject, eventdata, handles)

function no_degree_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Rectify_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' Normal form
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function NormalForm_Callback(hObject, eventdata, handles)

function Global3body_Callback(hObject, eventdata, handles)
ThreeBodyPlanar

function La_La_Callback(hObject, eventdata, handles)
global LaplaceDir PhSpGeoDir
La_La

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                     Menu' Help
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function Help_Callback(hObject, eventdata, handles)
% do nothing

function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','on');

function QuitHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','off');

function About_Callback(hObject, eventdata, handles)
About

function Credits_Callback(hObject, eventdata, handles)
Credits

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            End of code
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
