function varargout = ThreeBodyPlanar(varargin)

% Last Modified by GUIDE v2.5 19-Feb-2021 14:47:38

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
                   'gui_Singleton',  gui_Singleton, ...
                   'gui_OpeningFcn', @ThreeBodyPlanar_OpeningFcn, ...
                   'gui_OutputFcn',  @ThreeBodyPlanar_OutputFcn, ...
                   'gui_LayoutFcn',  [] , ...
                   'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before ThreeBodyPlanar is made visible.
function ThreeBodyPlanar_OpeningFcn(hObject, eventdata, handles, varargin)

% Choose default command line output for ThreeBodyPlanar
handles.output = hObject;

%%%%%%%%%%%%% Set LaTeX labels %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%color_def = [0.925  0.914  0.847];
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$m_0=$','FontSize',10,...
        'Position',[73 99 24 16])
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$m''=$','FontSize',10,...
        'Position',[180 102 19 14])    
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$m''''=$','FontSize',10,...
        'Position',[282 102 22 14])
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$a''=$','FontSize',10,...
        'Position',[126 68 17 14])
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$a''''=$','FontSize',10,...
        'Position',[247 68 22 14])
uibutton(handles.uipanel1,'Style','text','Interpreter','LaTex','String','$G_{tot}=$','FontSize',10,...
        'Position',[184 28 32 14])
uibutton(handles.uipanel5,'Style','text','Interpreter','LaTex','String','$\xi_1=$','FontSize',10,...
        'Position',[15 101 21 14])
uibutton(handles.uipanel5,'Style','text','Interpreter','LaTex','String','$\phi=$','FontSize',10,...
        'Position',[15 71 24 14])
    
% Update handles structure
guidata(hObject, handles);        
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% UIWAIT makes ThreeBodyPlanar wait for user response (see UIRESUME)
% uiwait(handles.figure1);

% --- Outputs from this function are returned to the command line.
function varargout = ThreeBodyPlanar_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         Plot unperturbed trajectories
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function edit_Gtot_Callback(hObject, eventdata, handles)
Gtotal = str2num(get(handles.edit_Gtot,'String'));
if (Gtotal < 0 | Gtotal > 1)
    warndlg('Gtot must be positive or null and less than or equal to 1')
end

function edit_xi1_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
valstr = get(handles.edit_xi1,'String');
val = str2num(valstr);
val = (val - ximin)/(ximax - ximin);
set(handles.slider_xi1,'Value',val)

function slider_xi1_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
val = get(handles.slider_xi1,'Value');
val = ximin + val*(ximax - ximin);
valstr = num2str(val);
set(handles.edit_xi1,'String',valstr)

function edit_phi_Callback(hObject, eventdata, handles)
valstr = get(handles.edit_phi,'String');
set(handles.slider_phi,'Value',str2num(valstr))

function slider_phi_Callback(hObject, eventdata, handles)
valstr = num2str(get(handles.slider_phi,'Value'));
set(handles.edit_phi,'String',valstr)

function pushbutton_trjct_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
if (Gtotal < 0 | Gtotal > 1)
    warndlg('Gtot must be positive or null and less than or equal to 1')
    return
end
xi1 = ximin + get(handles.slider_xi1,'Value')*(ximax-ximin);
set(handles.edit_xi1,'String',num2str(xi1))
phi = str2num(get(handles.edit_phi,'String'));
s = 0 : 0.01 : 2*pi;
G1 = (Gtot - xi1)/2;
G2 = (Gtot + xi1)/2;
e1 = sqrt(abs(1 - G1^2/L1^2));
e2 = sqrt(abs(1 - G2^2/L2^2));
Eps1 = G1/L1;
Eps2 = G2/L2;
s1 = 0 : 0.01 : 2*pi;
X1 = a1*(cos(s) - e1);
Y1 = a1*Eps1*sin(s);
X2 = cos(pi/180*phi)*a2*(cos(s) - e2) - sin(pi/180*phi)*a2*Eps2*sin(s);
Y2 = sin(pi/180*phi)*a2*(cos(s) - e2) + cos(pi/180*phi)*a2*Eps2*sin(s);
figure      
plot(-sigma1*X1,-sigma1*Y1,'LineWidth',2,'Color','r')
hold on
plot(sigma0*X1,sigma0*Y1,'LineWidth',2,'Color','b')
plot(X2,Y2,'LineWidth',2,'Color','k')
s = -a2 : 0.01 : a2;
plot(s,0); plot(0,s)
%legend('\it\sigma_0Q''','\it-\sigma_1Q''','\itQ''''')
legend('\it  m_0','\it  m''','\it  m''''')
axis equal
title('Trajectories of the three masses', 'FontSize',12)
xlabel('\itQ_1', 'FontSize',14), ylabel('\itQ_2', 'FontSize',14)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%            Vertical section
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_plot_sect_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
if (Gtotal < 0 | Gtotal > 1)
    warndlg('Gtot must be positive or null and less than or equal to 1')
    return
end
%%%%%%%%% Section of reduced manifold and level lines of averaged Hp %%%%%%
xi1 = ximin - 0.4*(ximax - ximin) : (ximax-ximin)/100 : ximax + 0.4*(ximax - ximin);
xi2 = -2*L1*L2 : 4*L1*L2/1.8/100 : 2*L1*L2;
[XI1,XI2] = meshgrid(xi1,xi2);
G1 = (Gtot - XI1)/2;
G2 = (Gtot + XI1)/2;
e1 = sqrt(1 - G1.^2/L1^2);
e2 = sqrt(1 - G2.^2/L2^2);
Eps2 = G2/L2;

H2 = (2 + 3*e1.^2)*(sigma0 + sigma1)/8./Eps2.^3;
H3 = 15*a1*(4 + 3*e1.^2)*(sigma0^2 - sigma1^2).*XI2/128/a2./Eps2.^5/L1/L2;
H4 = -(9*a1^2*(sigma0^3 + sigma1^3)*((20*e1.^2.*(-4+e2.^2)-8*(2+3*e2.^2)+5*e1.^4.*(-6+5*e2.^2))*L1^2*L2^2 ...
          -35*(2+e1.^2).*XI2.^2))/1024/a2^2./Eps2.^7/L1^2/L2^2;
H5 = (105*a1^3*(sigma0^4-sigma1^4)*XI2.*((e1.^2.*(160-48*e2.^2)+e1.^4.*(40-33*e2.^2)+16*(4+3*e2.^2))*L1^2*L2^2 ...
          +7*(8+3*e1.^2).*XI2.^2))/8192/a2^3./Eps2.^9/L1^3/L2^3;
H6 = (5*a1^4*(sigma0^5 + sigma1^5)*(2*(-1680*e1.^2.*(-8 - 4*e2.^2 + 3*e2.^4) ... 
          + 210*e1.^4.*(80 - 80*e2.^2 + 9*e2.^4) + 160*(8 + 40*e2.^2 + 15*e2.^4) ... 
          + 7*e1.^6.*(400 - 700*e2.^2 + 291*e2.^4))* L1^4*L2^4 - 126*(-240*(2 + e2.^2) ... 
          + 20*e1.^2.*(-40 + 13*e2.^2) + 3*e1.^4.*(-50 + 41*e2.^2))*L1^2*L2^2.*XI2.^2 ... 
          + 2079*(10 + 3*e1.^2).*XI2.^4))./(131072*a2^4*Eps2.^11*L1^4*L2^4);
H7 = (189*a1^5*(sigma0^6 - sigma1^6)*XI2.*(10*(320*(8 + 20*e2.^2 + 5*e2.^4) ... 
          - 120*e1.^2.*(-112 - 16*e2.^2 + 29*e2.^4) + 4*e1.^4.*(2800 - 2900*e2.^2 + 397*e2.^4) ... 
          + e1.^6.*(1400 - 2440*e2.^2 + 1007*e2.^4))*L1^4*L2^4 ... 
          - 330*(-40*(8 + 3*e2.^2) + 8*e1.^2.*(-50 + 17*e2.^2) ... 
          + e1.^4.*(-60 + 49*e2.^2))*L1^2*L2^2.*XI2.^2 + 4719*(4 ... 
          + e1.^2).*XI2.^4))./(4194304*a2^5*Eps2.^13*L1^5*L2^5);      
H8 = -(35*a1^6*(sigma0^7 + sigma1^7)*((20160*e1.^2.*(-64 - 144*e2.^2 + 40*e2.^4 + 25*e2.^6) ...
         - 4480*(16 + 168*e2.^2 + 210*e2.^4 + 35*e2.^6) - 3024*e1.^4.*(1120 - 560*e2.^2 - 590*e2.^4 + 173*e2.^6) ... 
         + 168*e1.^6.*(-11200 + 21000*e2.^2 - 10380*e2.^4 + 723*e2.^6) + 9*e1.^8.*(-19600 + 52920*e2.^2 - 46270*e2.^4 ... 
         + 12807*e2.^6))*L1^6*L2^6 - 198*(560*(48 + 80*e2.^2 + 15*e2.^4) - 168*e1.^2.*(-560 + 20*e2.^2 + 111*e2.^4) ... 
         + 42*e1.^4.*(1400 - 1480*e2.^2 + 223*e2.^4) + e1.^6.*(5880 - 10220*e2.^2 + 4197*e2.^4))*L1^4*L2^4.*XI2.^2 ... 
         + 14157*(-56*(10 + 3*e2.^2) + 28*e1.^2.*(-20 + 7*e2.^2) + e1.^4.*(-70 + 57*e2.^2))*L1^2*L2^2.*XI2.^4 ...
         - 61347*(14 + 3*e1.^2).*XI2.^6))./(33554432*a2^6*Eps2.^15*L1^6*L2^6);  
H9 =  (33*a1^7*(sigma0^8 - sigma1^8)*XI2.*(-105*(-1792*(64 + 336*e2.^2 + 280*e2.^4 + 35*e2.^6) ...
        + 3584*e1.^2.*(-288 - 368*e2.^2 + 170*e2.^4 + 57*e2.^6) - 1344*e1.^4.*(1344 - 952*e2.^2 - 412*e2.^4 + 163*e2.^6) ... 
        + 64*e1.^6.*(-11760 + 22344.*e2.^2 - 11410*e2.^4 + 969*e2.^6) + e1.^8.*(-56448 + 152096*e2.^2 - 132560*e2.^4 ... 
        + 36483*e2.^6))*L1^6*L2^6 + 10010*(896*(16 + 20*e2.^2 + 3*e2.^4) - 672*e1.^2.*(-56 + 8*e2.^2 + 9*e2.^4) ... 
        + 48*e1.^4.*(392 - 420*e2.^2 + 67*e2.^4) + e1.^6.*(1568 - 2720*e2.^2 + 1113*e2.^4))*L1^4*L2^4.*XI2.^2 ... 
        - 39039*(-672*(4 + e2.^2) + 160*e1.^2.*(-14 + 5*e2.^2) + 15*e1.^4.*(-16 + 13*e2.^2))*L1^2*L2^2.*XI2.^4 ... 
        + 474045*(16 + 3*e1.^2).*XI2.^6))./(268435456*a2^7*Eps2.^17*L1^7*L2^7);
H10 = (27*a1^8*(sigma0^9 + sigma1^9)*(14*(-295680*e1.^2.*(-128 - 640*e2.^2 - 224*e2.^4 + 280*e2.^6 + 49*e2.^8) ... 
        + 147840*e1.^4.*(1152 + 768*e2.^2 - 1936*e2.^4 + 80*e2.^6 + 157*e2.^8) ... 
        + 10752*(128 + 2304*e2.^2 + 6048*e2.^4 + 3360*e2.^6 + 315*e2.^8) ... 
        - 10560*e1.^6.*(-18816 + 28224.*e2.^2 - 2352*e2.^4 - 8344*e2.^6 + 1509*e2.^8) ... 
        + 330*e1.^8.*(188160 - 526848*e2.^2 + 492352*e2.^4 - 160960*e2.^6 + 7959*e2.^8) ... 
        + 11*e1.^10.*(338688 - 1241856*e2.^2 + 1675968*e2.^4 - 976440*e2.^6 + 202535*e2.^8))*L1^8*L2^8 ... 
        - 20020*(-5376*(32 + 112*e2.^2 + 70*e2.^4 + 7*e2.^6) + 5376*e1.^2.*(-192 - 152*e2.^2 + 100*e2.^4 + 23*e2.^6) ... 
        - 576*e1.^4.*(2352 - 1960*e2.^2 - 406*e2.^4 + 235*e2.^6) ... 
        + 24*e1.^6.*(-18816 + 36064*e2.^2 - 18800*e2.^4 + 1773*e2.^6) + e1.^8.*(-28224 + 75936*e2.^2 - 66030*e2.^4 ... 
        + 18097*e2.^6))*L1^6*L2^6.*XI2.^2 + 260260*(6720*(8 + 8*e2.^2 + e2.^4) - 288*e1.^2.*(-392 + 84*e2.^2 + 53*e2.^4) ... 
        + 30*e1.^4.*(1568 - 1696*e2.^2 + 281*e2.^4) + 5*e1.^6.*(672 - 1164*e2.^2 + 475*e2.^4))*L1^4*L2^4.*XI2.^4 ... 
        - 4424420*(-96*(14 + 3*e2.^2) + 12*e1.^2.*(-80 + 29*e2.^2) + e1.^4.*(-90 + 73*e2.^2))*L1^2*L2^2.*XI2.^6 ... 
        + 51038845*(6 + e1.^2).*XI2.^8))./(8589934592*a2^8*Eps2.^19*L1^8*L2^8);    
series_sect = str2num(get(handles.edit_series_sect,'String'));
if (series_sect < 3) | (series_sect > 10)
    warndlg('The number of terms in development series must be chosen between 3 and 10')
    return
end
Hp = H2;
for k = 3:series_sect
    ks = num2str(k);
    Hp = eval(['Hp + H',ks,';']);
end
          
figure
surf_sect = str2num(get(handles.edit_surf_sect,'String'));
contour(XI1,XI2,Hp,surf_sect,'-k')
hold on
s = ximin : (ximax-ximin)/200 : ximax;
XI1 = s;
XI2 = real(2*sqrt(L1^2-(Gtot - s).^2/4).*sqrt(L2^2-(Gtot + s).^2/4));
plot(XI1,XI2,'b','LineWidth',3);
XI2 = -XI2;
plot(XI1,XI2,'b','LineWidth',3);
title({'Section of reduced manifold';'and level lines of averaged \itH_p'}, 'FontSize',12)
xlabel('\it\xi_1', 'FontSize',14), ylabel('\it\xi_2', 'FontSize',14,'Rotation',0.0)
hold off
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%         Action-Angle dynamics (analytical)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_plot_anal_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
if (Gtotal < 0 | Gtotal > 1)
    warndlg('Gtot must be positive or null and less than or equal to 1')
    return
end
npoint = str2num(get(handles.edit_point_num,'String'));
xi1 = ximin : (ximax-ximin)/npoint : ximax;
phi = -180 : 180/npoint : 180;
[XI1,PHI] = meshgrid(xi1,phi);
G1 = (Gtot - XI1)/2;
G2 = (Gtot + XI1)/2;
e1 = sqrt(abs(1 - G1.^2/L1^2));
e2 = sqrt(abs(1 - G2.^2/L2^2));
Eps2 = G2/L2;
XI2 = -2*L1*L2*e1.*e2.*cos(pi/180*PHI);

H2 = (2 + 3*e1.^2)*(sigma0 + sigma1)/8./Eps2.^3;
H3 = 15*a1*(4 + 3*e1.^2)*(sigma0^2 - sigma1^2).*XI2/128/a2./Eps2.^5/L1/L2;
H4 = -(9*a1^2*(sigma0^3 + sigma1^3)*((20*e1.^2.*(-4+e2.^2)-8*(2+3*e2.^2)+5*e1.^4.*(-6+5*e2.^2))*L1^2*L2^2 ...
          -35*(2+e1.^2).*XI2.^2))/1024/a2^2./Eps2.^7/L1^2/L2^2;
H5 = (105*a1^3*(sigma0^4-sigma1^4)*XI2.*((e1.^2.*(160-48*e2.^2)+e1.^4.*(40-33*e2.^2)+16*(4+3*e2.^2))*L1^2*L2^2 ...
          +7*(8+3*e1.^2).*XI2.^2))/8192/a2^3./Eps2.^9/L1^3/L2^3;
H6 = (5*a1^4*(sigma0^5 + sigma1^5)*(2*(-1680*e1.^2.*(-8 - 4*e2.^2 + 3*e2.^4) ... 
          + 210*e1.^4.*(80 - 80*e2.^2 + 9*e2.^4) + 160*(8 + 40*e2.^2 + 15*e2.^4) ... 
          + 7*e1.^6.*(400 - 700*e2.^2 + 291*e2.^4))* L1^4*L2^4 - 126*(-240*(2 + e2.^2) ... 
          + 20*e1.^2.*(-40 + 13*e2.^2) + 3*e1.^4.*(-50 + 41*e2.^2))*L1^2*L2^2.*XI2.^2 ... 
          + 2079*(10 + 3*e1.^2).*XI2.^4))./(131072*a2^4*Eps2.^11*L1^4*L2^4);      
H7 = (189*a1^5*(sigma0^6 - sigma1^6)*XI2.*(10*(320*(8 + 20*e2.^2 + 5*e2.^4) ... 
          - 120*e1.^2.*(-112 - 16*e2.^2 + 29*e2.^4) + 4*e1.^4.*(2800 - 2900*e2.^2 + 397*e2.^4) ... 
          + e1.^6.*(1400 - 2440*e2.^2 + 1007*e2.^4))*L1^4*L2^4 ... 
          - 330*(-40*(8 + 3*e2.^2) + 8*e1.^2.*(-50 + 17*e2.^2) ... 
          + e1.^4.*(-60 + 49*e2.^2))*L1^2*L2^2.*XI2.^2 + 4719*(4 ... 
          + e1.^2).*XI2.^4))./(4194304*a2^5*Eps2.^13*L1^5*L2^5);
H8 = -(35*a1^6*(sigma0^7 + sigma1^7)*((20160*e1.^2.*(-64 - 144*e2.^2 + 40*e2.^4 + 25*e2.^6) ...
         - 4480*(16 + 168*e2.^2 + 210*e2.^4 + 35*e2.^6) - 3024*e1.^4.*(1120 - 560*e2.^2 - 590*e2.^4 + 173*e2.^6) ... 
         + 168*e1.^6.*(-11200 + 21000*e2.^2 - 10380*e2.^4 + 723*e2.^6) + 9*e1.^8.*(-19600 + 52920*e2.^2 - 46270*e2.^4 ... 
         + 12807*e2.^6))*L1^6*L2^6 - 198*(560*(48 + 80*e2.^2 + 15*e2.^4) - 168*e1.^2.*(-560 + 20*e2.^2 + 111*e2.^4) ... 
         + 42*e1.^4.*(1400 - 1480*e2.^2 + 223*e2.^4) + e1.^6.*(5880 - 10220*e2.^2 + 4197*e2.^4))*L1^4*L2^4.*XI2.^2 ... 
         + 14157*(-56*(10 + 3*e2.^2) + 28*e1.^2.*(-20 + 7*e2.^2) + e1.^4.*(-70 + 57*e2.^2))*L1^2*L2^2.*XI2.^4 ...
         - 61347*(14 + 3*e1.^2).*XI2.^6))./(33554432*a2^6*Eps2.^15*L1^6*L2^6);   
H9 =  (33*a1^7*(sigma0^8 - sigma1^8)*XI2.*(-105*(-1792*(64 + 336*e2.^2 + 280*e2.^4 + 35*e2.^6) ...
        + 3584*e1.^2.*(-288 - 368*e2.^2 + 170*e2.^4 + 57*e2.^6) - 1344*e1.^4.*(1344 - 952*e2.^2 - 412*e2.^4 + 163*e2.^6) ... 
        + 64*e1.^6.*(-11760 + 22344.*e2.^2 - 11410*e2.^4 + 969*e2.^6) + e1.^8.*(-56448 + 152096*e2.^2 - 132560*e2.^4 ... 
        + 36483*e2.^6))*L1^6*L2^6 + 10010*(896*(16 + 20*e2.^2 + 3*e2.^4) - 672*e1.^2.*(-56 + 8*e2.^2 + 9*e2.^4) ... 
        + 48*e1.^4.*(392 - 420*e2.^2 + 67*e2.^4) + e1.^6.*(1568 - 2720*e2.^2 + 1113*e2.^4))*L1^4*L2^4.*XI2.^2 ... 
        - 39039*(-672*(4 + e2.^2) + 160*e1.^2.*(-14 + 5*e2.^2) + 15*e1.^4.*(-16 + 13*e2.^2))*L1^2*L2^2.*XI2.^4 ... 
        + 474045*(16 + 3*e1.^2).*XI2.^6))./(268435456*a2^7*Eps2.^17*L1^7*L2^7);
H10 = (27*a1^8*(sigma0^9 + sigma1^9)*(14*(-295680*e1.^2.*(-128 - 640*e2.^2 - 224*e2.^4 + 280*e2.^6 + 49*e2.^8) ... 
        + 147840*e1.^4.*(1152 + 768*e2.^2 - 1936*e2.^4 + 80*e2.^6 + 157*e2.^8) ... 
        + 10752*(128 + 2304*e2.^2 + 6048*e2.^4 + 3360*e2.^6 + 315*e2.^8) ... 
        - 10560*e1.^6.*(-18816 + 28224.*e2.^2 - 2352*e2.^4 - 8344*e2.^6 + 1509*e2.^8) ... 
        + 330*e1.^8.*(188160 - 526848*e2.^2 + 492352*e2.^4 - 160960*e2.^6 + 7959*e2.^8) ... 
        + 11*e1.^10.*(338688 - 1241856*e2.^2 + 1675968*e2.^4 - 976440*e2.^6 + 202535*e2.^8))*L1^8*L2^8 ... 
        - 20020*(-5376*(32 + 112*e2.^2 + 70*e2.^4 + 7*e2.^6) + 5376*e1.^2.*(-192 - 152*e2.^2 + 100*e2.^4 + 23*e2.^6) ... 
        - 576*e1.^4.*(2352 - 1960*e2.^2 - 406*e2.^4 + 235*e2.^6) ... 
        + 24*e1.^6.*(-18816 + 36064*e2.^2 - 18800*e2.^4 + 1773*e2.^6) + e1.^8.*(-28224 + 75936*e2.^2 - 66030*e2.^4 ... 
        + 18097*e2.^6))*L1^6*L2^6.*XI2.^2 + 260260*(6720*(8 + 8*e2.^2 + e2.^4) - 288*e1.^2.*(-392 + 84*e2.^2 + 53*e2.^4) ... 
        + 30*e1.^4.*(1568 - 1696*e2.^2 + 281*e2.^4) + 5*e1.^6.*(672 - 1164*e2.^2 + 475*e2.^4))*L1^4*L2^4.*XI2.^4 ... 
        - 4424420*(-96*(14 + 3*e2.^2) + 12*e1.^2.*(-80 + 29*e2.^2) + e1.^4.*(-90 + 73*e2.^2))*L1^2*L2^2.*XI2.^6 ... 
        + 51038845*(6 + e1.^2).*XI2.^8))./(8589934592*a2^8*Eps2.^19*L1^8*L2^8);
series_anal = str2num(get(handles.edit_series_anal,'String'));
if (series_anal < 3) | (series_anal > 10)
    warndlg('The number of terms in development series must be chosen between 3 and 10')
    return
end
Hp = H2;
for k = 3:series_anal
    ks = num2str(k);
    Hp = eval(['Hp + H',ks,';']);
end
%Hp = real(Hp);
%%{
if isreal(Hp)
    %do nothing
else
    warndlg('Some values of Hp are not real')
    return
end
%%}          
figure
surf_anal = str2num(get(handles.edit_surf_anal,'String'));
contour(PHI,XI1,Hp,surf_anal,'-k')
title('Action-Angle: \it\xi_1, \phi \rm (analytical)', 'FontSize',12)
ylabel('\it\xi_1', 'FontSize',14,'Rotation',0.0), xlabel('\it\phi \rm(deg)', 'FontSize',14)
set(gca,'XTickLabel',{['-150' char(176)];['-100' char(176)];['-50' char(176)];['0' char(176)];...
    ['50' char(176)];['100' char(176)];['150' char(176)]});
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%          Action-Angle dynamics (numerical)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function pushbutton_plot_num_Callback(hObject, eventdata, handles)
ThreeBodyPlanarParameters
if (Gtotal < 0 | Gtotal > 1)
    warndlg('Gtot must be positive or null and less than or equal to 1')
    return
end
handle = waitbar(0,'Please, wait ...');
resol = str2num(get(handles.edit_Resolution,'String'));
Z = zeros(resol+1);
h = 1;  k = 0;
for xi1 = ximin : (ximax-ximin)/resol : ximax;
    for phi = 0 : 180/resol : 180;
        G1 = (Gtot - xi1)/2;
        G2 = (Gtot + xi1)/2;
        e1 = sqrt(abs(1 - G1^2/L1^2));
        e2 = sqrt(abs(1 - G2^2/L2^2));
        Eps1 = G1/L1;
        Eps2 = G2/L2;

        X1 = @(s1) a1*(cos(s1) - e1);
        Y1 = @(s1) a1*Eps1*sin(s1);
        X2 = @(s2) cos(pi/180*phi)*a2*(cos(s2) - e2) - sin(pi/180*phi)*a2*Eps2*sin(s2);
        Y2 = @(s2) sin(pi/180*phi)*a2*(cos(s2) - e2) + cos(pi/180*phi)*a2*Eps2*sin(s2);       
        q1 = @(s1) a1*(1 - e1*cos(s1));
        q2 = @(s2) a2*(1 - e2*cos(s2));
        Hp = @(s1,s2) 1/(2*pi)^2*(q1(s1)*q2(s2)./(sigma1*sqrt(sigma1^2*q1(s1).^2 + q2(s2).^2 ...
                 + 2*sigma1*(X1(s1).*X2(s2) + Y1(s1).*Y2(s2)))) ...
                 + q1(s1)*q2(s2)./(sigma0*sqrt(sigma0^2*q1(s1).^2 + q2(s2).^2 ...
                 - 2*sigma0*(X1(s1).*X2(s2) + Y1(s1).*Y2(s2)))));
        tol = str2num(get(handles.edit_Tolerance,'String'));
        Z(h,k+1) = dblquad(Hp,0,2*pi,0,2*pi,tol);
         
        h = h + 1;        
    end
    h = 1;
    k = k + 1;
    x = (k-1)/resol;
    waitbar(x,handle)    
end
if isreal(Z)
    %do nothing
else
    warndlg('Tolerance too stringent')
    return
end
xi1 = ximin : (ximax-ximin)/resol : ximax;
phi = 0 : 180/resol : 180;
[PHI,XI1] = meshgrid(phi,xi1);
figure
surf_num = str2num(get(handles.edit_surf_num,'String'));
contour(PHI,XI1,Z',surf_num,'-k')
title('Action-Angle: \it\xi_1, \phi \rm (numerical)', 'FontSize',12)
ylabel('\it\xi_1', 'FontSize',14,'Rotation',0.0), xlabel('\it\phi \rm(deg)', 'FontSize',14)
set(gca,'XTickLabel',{['0' char(176)];['20' char(176)];['40' char(176)];['60' char(176)];...
    ['80' char(176)];['100' char(176)];['120' char(176)];['140' char(176)];...
    ['160' char(176)];['180' char(176)]});
close(handle)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                        END of CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
