function varargout = Poincare(varargin)
% POINCARE M-file for Poincare.fig

% Last Modified by GUIDE v2.5 19-May-2015 22:40:17

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @Poincare_OpeningFcn, ...
    'gui_OutputFcn',  @Poincare_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT

% --- Executes just before Poincare is made visible.
function Poincare_OpeningFcn(hObject, eventdata, handles, varargin)
global PoincareDir PhSpGeoDir
PoincareDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(PoincareDir)
if isdeployed
    % do nothing
else
    path([PoincareDir,'/Help'],path);
    path([PhSpGeoDir,'/Util'], path);
    path([PhSpGeoDir,'/Util/Multicore'], path);
    path(PoincareDir, path);
end
%%%%%%%%%%%%%%%%%%% HELP %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Hfcn=['str=get(gco,''Tag'');'...
      'HelpScript'];
set(handles.figure1,'HelpFcn',Hfcn);
cshelp(handles.figure1);

keyFcn = ['if strcmp(get(gcbo,''CurrentKey''),''escape''), ' ...
              'set(gcbo,''CSHelpMode'',''off''); ' ...
          'elseif strcmp(get(gcbo,''CurrentKey''),''f2''), ' ...
              'set(gcbo,''CSHelpMode'',''on''); ' ...  
          'end'];     
set(handles.figure1,'keyPressFcn',keyFcn);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

ColorFont
handles.output = hObject;
if ~isnan(findstr(PoincareDir, 'Slave'))
    set(handles.pushbutton_StartSlave, 'Visible', 'on')
    set(handles.pushbutton_Calculate, 'Visible', 'off')
else
    cd ..
    if exist('multicorefiles')
        rmdir('multicorefiles','s')
    end
    cd(PoincareDir)
end

list = strread(cd, '%s','delimiter',strrep(filesep,'\','\\'));
dim = size(list);
%curdir = list{dim(1,1), dim(1,2)};
curdir = [list{dim(1,1), dim(1,2)},' - ',list{dim(1,1) - 1, dim(1,2)}];
set(handles.figure1, 'Name', curdir)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                  Load saved on exit
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
cd(PoincareDir)
cd ..
if exist('Setting.mat')
    load('Setting.mat')
    SetInit
end
cd(PoincareDir)

if get(handles.popupMAP,'Value') == 1
    set(handles.edit_epsilon2,'Enable','off')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 2
    set(handles.edit_epsilon2,'Enable','on')
    set(handles.edit_epsilon3,'Enable','on')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 3
    set(handles.edit_epsilon2,'Enable','on')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 4
    set(handles.edit_epsilon2,'Enable','off')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','on')
end

% Update handles structure
guidata(hObject, handles);

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
if ~isnan(findstr(PoincareDir, 'Slave'))
    Totalbar = waitbar(0,'Please wait..., POINCARE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Outputs from this function are returned to the command line.
function varargout = Poincare_OutputFcn(hObject, eventdata, handles) 

% Get default command line output from handles structure
varargout{1} = handles.output;

% --- Executes during object deletion, before destroying properties.
function figure1_DeleteFcn(hObject, eventdata, handles)
global PoincareDir PhSpGeoDir
if ~isnan(findstr(PoincareDir, 'Slave'))
%do nothing
else
    if strcmp(get(handles.Save_exit, 'Checked'),'on')     
        cd(PoincareDir)
        InitStructure
        cd ..        
        save('Setting.mat', '-struct', 'InitStr')
        cd(PoincareDir)
    end
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function popupMAP_Callback(hObject, eventdata, handles)
if get(handles.popupMAP,'Value') == 1
    set(handles.edit_epsilon2,'Enable','off')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 2
    set(handles.edit_epsilon2,'Enable','on')
    set(handles.edit_epsilon3,'Enable','on')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 3
    set(handles.edit_epsilon2,'Enable','on')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','off')
end
if get(handles.popupMAP,'Value') == 4
    set(handles.edit_epsilon2,'Enable','off')
    set(handles.edit_epsilon3,'Enable','off')
    set(handles.edit_m,'Enable','on')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function step_1_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end

function step_2_Callback(hObject, eventdata, handles)
if str2num(get(gcbo,'String')) < 1
    warndlg('The entry must be a positive integer','Invalid entry')
    set(gcbo,'String','1')
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% --- Executes on button press in pushbutton_Calculate.
function pushbutton_Calculate_Callback(hObject, eventdata, handles)
x1_in = str2num(get(handles.x1_in,'String'));
x2_in = str2num(get(handles.x2_in,'String'));
x1_fin = str2num(get(handles.x1_fin,'String'));
x2_fin = str2num(get(handles.x2_fin,'String'));
numstep_x1 = str2num(get(handles.step_1,'String'));
numstep_x2 = str2num(get(handles.step_2,'String'));
row_tot = numstep_x2 + 1;
col_tot = numstep_x1 + 1;
ext_tot = max(row_tot, col_tot);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
begin = datestr(now, 'dd mmm HH:MM');
global PoincareDir PhSpGeoDir
if ~isnan(findstr(PoincareDir, 'Slave'))
% do nothing
else
    Totalbar = waitbar(0,'Please wait..., POINCARE is calculating.',...
        'Units', 'pixel', 'Position', [392 570 380 70]);
end

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
display('                                                                 ')
display('###################################################################')
display('    STARTING COMPUTATION !!!')
disp('    ')
tic
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%---------------------- Start multicore -----------------------------------
parameterCell = cell(1,ext_tot);
subcell = cell(1,4);
for ext = 1:ext_tot
    subcell{1,1} = [ext];
    subcell{1,2} = [handles];
    subcell{1,3} = [Totalbar];
    subcell{1,4} = [begin];    
    parameterCell{1,ext} = {subcell};
end

cd ..
fid = fopen('WaitBar.txt','w');
fwrite(fid,'0');
fclose(fid);
cd(PoincareDir)

warning('off')
resultCell = startmulticoremaster(@paralfor, parameterCell, '../multicorefiles');
warning('on')
%---------------------- End multicore -----------------------------------
FMI_1 = [resultCell{1,1}(1,:)];
for k = 2 : ext_tot
    FMI_1 = [FMI_1; resultCell{1,k}(1,:)];
end
FMI_2 = [resultCell{1,1}(2,:)];
for k = 2 : ext_tot
    FMI_2 = [FMI_2; resultCell{1,k}(2,:)];
end

if row_tot <= col_tot
    FMI_1 = FMI_1';
    FMI_2 = FMI_2';
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                    Save to file
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
save FMI1.dat FMI_1 -ascii
save FMI2.dat FMI_2 -ascii      
delete *.txt
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
x1 = x1_in : (x1_fin - x1_in)/numstep_x1 : x1_fin;
x2 = x2_in : (x2_fin - x2_in)/numstep_x2 : x2_fin;

if str2num(get(handles.Step_FMI1,'String')) > 0;
    figure
    colormap(gray)
    surf(x1, x2, FMI_1, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itx_1', 'FontSize',14), ylabel('\itx_2', 'FontSize',14)
    title({'FMI 1'}, 'FontSize',14)
end

if str2num(get(handles.Step_FMI2,'String')) > 0;
    figure
    colormap(gray)
    surf(x1, x2, FMI_2, 'FaceColor', 'interp', 'LineStyle', 'none');
    view(2)
    xlabel('\itx_1', 'FontSize',14), ylabel('\itx_2', 'FontSize',14)
    title({'FMI 2'}, 'FontSize',14)
end

display('-------------------------------------------------------------------')
display('            FINISH !!!')
toc
display('###################################################################')
set(handles.count,'String', '0');

function count_Callback(hObject, eventdata, handles)

function count_CreateFcn(hObject, eventdata, handles)

function pushbutton_StartSlave_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartSlave, 'Enable', 'off', 'String', 'Slave is running', 'FontSize', 10)
startmulticoreslave('../multicorefiles')

function pushbutton_StartLFA_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StartLFA,'Enable','off')
set(handles.pushbutton_StopLFA,'Enable','on')
set(handles.pushbutton_StartLFA,'Visible','off')
set(handles.pushbutton_StopLFA,'Visible','on')
close all
pause(1)
PoincareDir = cd;
cd ..
cd ..
PhSpGeoDir = cd;
cd(PoincareDir);

global epsilon1  epsilon2  epsilon3  m
epsilon1 = str2num(get(handles.edit_epsilon1,'String'));
epsilon2 = str2num(get(handles.edit_epsilon2,'String'));
epsilon3 = str2num(get(handles.edit_epsilon3,'String'));
m        = str2num(get(handles.edit_m,'String'));
contents = get(handles.popupMAP,'String');
item = get(handles.popupMAP,'Value');
MAP = char(contents(item));
x1_o = str2num(get(handles.x1_o,'String'));
x2_o = str2num(get(handles.x2_o,'String'));
tau_total = str2num(get(handles.edit_iteration,'String'));
ktime = 1;
W = zeros(tau_total,4);
Inpt = [x1_o  x2_o  0  0];
W(1,:) = Inpt;

while strcmp(get(handles.pushbutton_StopLFA,'Visible'),'on')
    for tau = 2:tau_total
        W(tau,:) = eval([MAP,'(Inpt)']);
        Inpt = W(tau,:);
    end
    %%%%%%%%%%%%%%%%%% Write inputAct1.txt %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Act1x = W(:,1).*cos(W(:,3));
    Act1y = W(:,1).*sin(W(:,3));
    tau = 1:tau_total;
    fid = fopen('inputAct1.txt', 'wt');
    fprintf(fid, '%14.10f %14.10f %14.10f\n',...
        [tau ; Act1x'; Act1y']);
    fclose(fid);
    %%%%%%%%%%%%%%%%%% Write inputAct2.txt %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    Act2x = W(:,2).*cos(W(:,4));
    Act2y = W(:,2).*sin(W(:,4));
    fid = fopen('inputAct2.txt', 'wt');
    fprintf(fid, '%14.10f %14.10f %14.10f\n',...
        [tau ; Act2x'; Act2y']);
    fclose(fid);
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    min_f = str2num(get(handles.freq1_min,'String'));
    max_f = str2num(get(handles.freq1_max,'String'));
    min_f = num2str(1000*min_f,'%6.12f');
    max_f = num2str(1000*max_f,'%6.12f');
    flag_FMFT = num2str(1);
    nfreq = num2str(1);
    data_sep = num2str(2*pi*100000*0.05*3.18303);  
    d = size(W(:,1),1);    
    ndata = num2str(2^(floor(log2(d))));
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
        data_sep,' ',ndata,' ','<inputAct1.txt',' ','>FMFT_of_Act1.txt'];  
    eval(cmd_string) 
    freq1 = textread('FMFT_of_Act1.txt', '%f %*f %*f', 'headerlines', 4);
    if numel(freq1)== 0
        warndlg('Some error occurred: the corresponding frequency value will be left blank.')
        freq1 = NaN;
        cd(PoincareDir)
        break
    end
    
    min_f = str2num(get(handles.freq2_min,'String'));
    max_f = str2num(get(handles.freq2_max,'String'));
    min_f = num2str(1000*min_f,'%6.12f');
    max_f = num2str(1000*max_f,'%6.12f');    
    cmd_string = ['!',PhSpGeoDir,'/AddedODEsolver/bin/main_fmft ',min_f,' ',max_f,' ',flag_FMFT,' ',nfreq,' ',...
        data_sep,' ',ndata,' ','<inputAct2.txt',' ','>FMFT_of_Act2.txt'];  
    eval(cmd_string) 
    freq2 = textread('FMFT_of_Act2.txt', '%f %*f %*f', 'headerlines', 4);
    if numel(freq2)== 0
        warndlg('Some error occurred: the corresponding frequency value will be left blank.')
        freq2 = NaN;
        cd(PoincareDir)
        break
    end
 pause(0.01)   
    tm = ktime*tau_total;
    figure(1);
    hold on
    plot(tm,freq1,'.r','MarkerSize',10)
    %plot(tm,freq1,'-r')
    title('Frequency 1')    
    xlabel('Iterations', 'FontSize',10)
    ylabel('Frequency \times 1000')
    tm = ktime*tau_total;
    
    figure(2);
    hold on
    plot(tm,freq2,'.r','MarkerSize',10)
    %plot(tm,freq2,'-r')
    title('Frequency 2')    
    xlabel('Iterations', 'FontSize',10)
    ylabel('Frequency \times 1000')    
   
    
    ktime = ktime + 1;   
end

function pushbutton_StopLFA_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StopLFA,'Visible','off');
set(handles.pushbutton_StartLFA,'Visible','on');
set(handles.pushbutton_StopLFA,'Enable','off');
set(handles.pushbutton_StartLFA,'Enable','on');

function x1_o_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StopLFA,'Visible','off');
set(handles.pushbutton_StartLFA,'Visible','on');
set(handles.pushbutton_StopLFA,'Enable','off');
set(handles.pushbutton_StartLFA,'Enable','on');

function x2_o_Callback(hObject, eventdata, handles)
set(handles.pushbutton_StopLFA,'Visible','off');
set(handles.pushbutton_StartLFA,'Visible','on');
set(handles.pushbutton_StopLFA,'Enable','off');
set(handles.pushbutton_StartLFA,'Enable','on');

%%%%%%%%%%%%%%%%%%% MENU %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function savesetting_Callback(hObject, eventdata, handles)
% do nothing

function Save_exit_Callback(hObject, eventdata, handles)
if strcmp(get(gcbo, 'Checked'),'on')
    set(gcbo, 'Checked','off');
else
    set(gcbo, 'Checked','on');
end

function Save_now_Callback(hObject, eventdata, handles)
global PoincareDir PhSpGeoDir
InitStructure
cd(PoincareDir)
cd ..        
save('Setting.mat', '-struct', 'InitStr')
cd(PoincareDir)

function save_fig_Callback(hObject, eventdata, handles)
if isempty(get(0,'CurrentFigure'))
%    set(handles.save_eps,'Enable','off')
    set(handles.save_pdf,'Enable','off')
    set(handles.save_png,'Enable','off')
    set(handles.jpeg2eps,'Enable','off')
else
%    set(handles.save_eps,'Enable','on')
    set(handles.save_pdf,'Enable','on')
    set(handles.save_png,'Enable','on')
    set(handles.jpeg2eps,'Enable','on')
end
%{
function save_eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'eps', '-fonts')   
else
    savfig(name, 'eps', '-fonts')
end
%}
function save_pdf_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'pdf', '-fonts')   
else
    savfig(name, 'pdf', '-fonts')
end

function save_png_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
if strcmp(name, '')
    savfig('CurrentFigure', 'png', '-r1200')   
else
    savfig(name, 'png', '-r1200')
end

function jpeg2eps_Callback(hObject, eventdata, handles)
[pathstr, name, ext] = fileparts(get(gcf, 'FileName'));
global PhSpGeoDir
if strcmp(name, '')
    savfig('CurrentFigure', 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 CurrentFigure.jpeg > CurrentFigure.eps'];
    eval(cmd_string)
else
    savfig(name, 'jpeg', '-r1200')
    cmd_string = ['!',PhSpGeoDir,'/Util/jpeg2ps -r 0 ',name,'.jpeg > ',name,'.eps'];
    eval(cmd_string)    
end

function Help_Callback(hObject, eventdata, handles)
% do nothing

function EnterHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','on');

function EscHelp_Callback(hObject, eventdata, handles)
set(handles.figure1,'CSHelpMode','off');

function About_Callback(hObject, eventdata, handles)
About

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                 END of CODE
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
